#ifndef SINGLETOPDPDMAKER_ELECTRONETACRACKFILTER_H
#define SINGLETOPDPDMAKER_ELECTRONETACRACKFILTER_H

#include <string>

#include "GaudiKernel/Algorithm.h"
#include "GaudiKernel/MsgStream.h"
#include "StoreGate/StoreGate.h"

#include "egammaEvent/ElectronContainer.h"
#include "egammaEvent/Electron.h"

class ElectronEtaCrackFilter : public Algorithm
{

public:

  ElectronEtaCrackFilter(const std::string& name, ISvcLocator* pSvcLocator);
  virtual ~ElectronEtaCrackFilter();
  
  StatusCode initialize();
  StatusCode finalize();
  StatusCode execute();
          
private:

  StoreGateSvc * aStoreGateSvc;
  
  int InputEventNumber;
  int OutputEventNumber;    

  std::string ElectronContainerName;
  
  const ElectronContainer * aElectronContainer;
  
  double MinEtaCrack;
  double MaxEtaCrack;
  
  int MinNumber;
  int MaxNumber;
                        
};

#endif







