#ifndef SINGLETOPDPDMAKER_GLOBALVARIABLES_H
#define SINGLETOPDPDMAKER_GLOBALVARIABLES_H

#include <string>
#include <map>

#include "NavFourMom/INavigable4MomentumCollection.h"

#include "CLHEP/Vector/LorentzVector.h"

#include "TMatrixD.h"
#include "TDecompSVD.h"
#include "TVectorD.h"

namespace GlobalVariables
{

  double PtSum(INavigable4MomentumCollection*);
  
  double PzSum(INavigable4MomentumCollection*);
  
  double Shat(INavigable4MomentumCollection*);
  
  double InvariantMass(INavigable4MomentumCollection*);
  
  std::map<std::string, double> TopologicalVariables(INavigable4MomentumCollection*);

}

#endif
