#ifndef SINGLETOPDPDMAKER_JETSELECTION_H
#define SINGLETOPDPDMAKER_JETSELECTION_H

#include <string>

#include "GaudiKernel/Algorithm.h"
#include "GaudiKernel/MsgStream.h"
#include "StoreGate/StoreGate.h"

#include "JetEvent/JetCollection.h"
#include "JetEvent/Jet.h"

#include "SingleTopDPDMaker/SelectionInfoContainer.h"
#include "SingleTopDPDMaker/SelectionInfo.h"

class JetSelection : public Algorithm
{

public:

  JetSelection(const std::string& name, ISvcLocator* pSvcLocator);
    
  virtual ~JetSelection();
  
  StatusCode initialize();
  StatusCode finalize();
  StatusCode execute();
  
  void Select();
  
  bool SelectJet(const Jet*);
    
private:

  StoreGateSvc * aStoreGateSvc;
  
  int InputEventNumber;
  int OutputEventNumber;
  
  int InputObjectNumber;
  int OutputObjectNumber;
  
  std::string InputContainerName;
  std::string OutputContainerName;
  
  std::string SelectionInfoContainerName;
  std::string SelectionLabel;
  
  const JetCollection * aInputContainer;
  JetCollection       * aOutputContainer;
    
  double PtCut;
  double EtaCut;
  
  std::vector<bool> Mask;
  
  SelectionInfoContainer * aSelectionInfoContainer;

};

#endif
