#ifndef SINGLETPDPDMAKER_JETSLIMMING_H
#define SINGLETPDPDMAKER_JETSLIMMING_H

#include <string>
#include <vector>

#include "GaudiKernel/Algorithm.h"
#include "GaudiKernel/MsgStream.h"
#include "StoreGate/StoreGate.h"

#include "JetEvent/JetCollection.h"
#include "JetEvent/Jet.h"

class JetSlimming : public Algorithm
{

public:

  JetSlimming(const std::string& name, ISvcLocator* pSvcLocator);
  virtual ~JetSlimming();
  
  StatusCode initialize();
  StatusCode finalize();
  StatusCode execute();
  
  void Slim(const JetCollection*);
  
private:

  StoreGateSvc * aStoreGateSvc;
  
  int InputEventNumber;
  int OutputEventNumber;

  std::vector<std::string> JetContainerName;
                        
};

#endif







