#ifndef SINGLETOPDPDMAKER_TRACKSLIMMING_H
#define SINGLETOPDPDMAKER_TRACKSLIMMING_H

#include <string>

#include "GaudiKernel/Algorithm.h"
#include "GaudiKernel/MsgStream.h"
#include "StoreGate/StoreGate.h"

#include "Particle/TrackParticleContainer.h"
#include "Particle/TrackParticle.h"

class TrackSlimming : public Algorithm
{

public:

  TrackSlimming(const std::string& name, ISvcLocator* pSvcLocator);
  virtual ~TrackSlimming();
  
  StatusCode initialize();
  StatusCode finalize();
  StatusCode execute();
  
  void Slim(const Rec::TrackParticleContainer*);
  
private:

  StoreGateSvc * aStoreGateSvc;
  
  int InputEventNumber;
  int OutputEventNumber;

  std::string TrackParticleContainerName;
  
  double TrackPtCut;
                        
};

#endif







