#ifndef SINGLETOPDPDMAKER_TRIGGERDECISIONINFO_H
#define SINGLETOPDPDMAKER_TRIGGERDECISIONINFO_H

#include <string>
#include <map>

#include "CLIDSvc/CLASS_DEF.h"

class TriggerDecisionInfo
{

public:

  TriggerDecisionInfo();
  TriggerDecisionInfo(const TriggerDecisionInfo&);
  virtual ~TriggerDecisionInfo();
  
  void SetPassedTrigger    (int);
  void SetPassedLevel1     (int);
  void SetPassedLevel2     (int);
  void SetPassedEventFilter(int);
  
  void SetPassedChain(std::map<std::string, int>&);
  
  int GetPassedTrigger()     const;
  int GetPassedLevel1()      const;
  int GetPassedLevel2()      const;
  int GetPassedEventFilter() const;
  
  std::map<std::string, int> GetPassedChain() const;

private:

  int PassedTrigger;
  int PassedLevel1;
  int PassedLevel2;
  int PassedEventFilter;
  
  std::map<std::string, int> PassedChain;
  
};

CLASS_DEF(TriggerDecisionInfo, 81690203, 0)

#endif
