#ifndef SINGLETOPDPDMAKER_TRUTHVERTEXFILTER_H
#define SINGLETOPDPDMAKER_TRUTHVERTEXFILTER_H

#include <string>

#include "GaudiKernel/Algorithm.h"
#include "GaudiKernel/MsgStream.h"
#include "GaudiKernel/ToolHandle.h"
#include "StoreGate/StoreGate.h"

#include "McParticleKernel/IMcVtxFilterTool.h"
#include "McParticleKernel/ITruthParticleCnvTool.h"

class TruthVertexFilter : public Algorithm
{

public:

  TruthVertexFilter(const std::string& name, ISvcLocator* pSvcLocator);
    
  virtual ~TruthVertexFilter();
  
  StatusCode initialize();
  StatusCode finalize();
  StatusCode execute();
      
private:

  StoreGateSvc * aStoreGateSvc;
  
  int InputEventNumber;
  int OutputEventNumber;
      
  ToolHandle<IMcVtxFilterTool>      aMcVtxFilterTool;
  ToolHandle<ITruthParticleCnvTool> aTruthParticleCnvTool;
    
};

#endif
