#ifndef SINGLETOPDPDMAKER_UNTAGGEDJETSELECTION_H
#define SINGLETOPDPDMAKER_UNTAGGEDJETSELECTION_H

#include <string>

#include "GaudiKernel/Algorithm.h"
#include "GaudiKernel/MsgStream.h"
#include "StoreGate/StoreGate.h"

#include "JetEvent/JetCollection.h"
#include "JetEvent/Jet.h"

class UntaggedJetSelection : public Algorithm
{

public:

  UntaggedJetSelection(const std::string& name, ISvcLocator* pSvcLocator);
    
  virtual ~UntaggedJetSelection();
  
  StatusCode initialize();
  StatusCode finalize();
  StatusCode execute();
  
  void Select();
  
  bool TestTaggingAlgorithmOption();
  
  bool SelectUntaggedJet(const Jet*);
    
private:

  StoreGateSvc * aStoreGateSvc;
  
  int InputEventNumber;
  int OutputEventNumber;
  
  int InputObjectNumber;
  int OutputObjectNumber;
  
  std::string InputContainerName;
  std::string OutputContainerName;
    
  const JetCollection * aInputContainer;
  JetCollection       * aOutputContainer;
    
  double PtCut;
  double EtaCut;
  
  std::string TaggingAlgorithm;
  double TaggingWeightCut;
  
};

#endif
