from TrigConfigSvc.TrigConfigSvcConfig import SetupTrigConfigSvc
from RecExConfig.Configured import Configured 
from AthenaCommon.Include import include

class TriggerConfigurationGetter(Configured):

  _output     = {}
  _configured = True
  _done       = False
    
  def configure(self):
    
    Service = SetupTrigConfigSvc()
    Service.SetStates(["ds"])
                            
    Service.l1XmlFile  = "outputLVL1config.xml"
    Service.hltXmlFile = "outputHLTconfig.xml"
    
    Service.InitialiseSvc()

    from AthenaCommon.AppMgr import theApp
            
    include("IOVDbSvc/IOVDbSvc_jobOptions.py")
    IOVDbSvc = theApp.service("IOVDbSvc")

    IOVDbSvc.Folders+=["/TRIGGER/HLT/Menu <tag>HEAD</tag>"]
    IOVDbSvc.Folders+=["/TRIGGER/HLT/HltConfigKeys <tag>HEAD</tag>"]
    IOVDbSvc.Folders+=["/TRIGGER/LVL1/Lvl1ConfigKey <tag>HEAD</tag>"]
    IOVDbSvc.Folders+=["/TRIGGER/LVL1/Menu <tag>HEAD</tag>"]
    IOVDbSvc.Folders+=["/TRIGGER/LVL1/Prescales <tag>HEAD</tag>"]

    return True
