#
# script for ganga submission
#

# Input and Output parameters

InputCollections  = ["jobInput.root"]

OutputFile = "jobOutput.root"
Label = "_e20i_PrimSel_Nlep.pt30.geq.1"
# Label = "_e20i_PrimSel_Nele.pt30.eq.2_test1"
OutputFileName = OutputFile

print OutputFileName

NbEventSkip = 0
NbEventMax  = 100000

Data     = True
FullReco = True
FDRData  = True

ChannelName  = "STt"
OutputFormat = "D3PD"

# Trigger
doTriggerDecision = True

# Sequence parameters

ExecutePrimarySelection    = True
ExecuteChannelPreSelection = False
ExecuteChannelSelection    = False

SelectTruth = False
RecordTruth = False

ApplySlimming = True
ApplyThinning = True

# Input, Output and Sequence parameter assignments

if Data:

  FullReco    = True
  SelectTruth = False
  RecordTruth = False
  
else:

  if not FullReco:
    ApplySlimming = False

if Data:
  EventInfoName = "ByteStreamEventInfo"
  
else :
  EventInfoName = "McEventInfo"

if FullReco:

#  MissingEtName              = "MET_RefFinal"
  MissingEtName              = "MET_Final"
  PhotonContainerName        = "PhotonAODCollection"
  ElectronContainerName      = "ElectronAODCollection"
  MuonContainerName          = "StacoMuonCollection"
  TauJetContainerName        = "TauRecContainer"
  JetContainerName           = "Cone4H1TowerJets"
  TrackParticleContainerName = "TrackParticleCandidate"
  
else:

  MissingEtName              = "AtlfastMissingEt"
  PhotonContainerName        = "AtlfastPhotonCollection"
  ElectronContainerName      = "AtlfastElectronCollection"
  MuonContainerName          = "AtlfastMuonCollection"
  TauJetContainerName        = "AtlfastTauJet1p3pContainer"
  JetContainerName           = "AtlfastJetContainer"
  TrackParticleContainerName = "AtlfastTrackParticles"
    
TruthMissingEtName         = "MET_Truth"
TruthParticleContainerName = "SpclMC"
McEventContainerName       = "GEN_AOD"


# Object PreSelection parameters

JetPreSelection_PtCut  = 15.0*GeV
JetPreSelection_EtaCut = 5.0

if FullReco:
  ElectronPreSelection_Author = "Electron"
  ElectronPreSelection_EmMask = "Medium"
else:
  ElectronPreSelection_Author = "All"
  ElectronPreSelection_EmMask = "None"
  
ElectronPreSelection_ApplyEtConeCut   = True
ElectronPreSelection_ConeSize         = 0.2 
ElectronPreSelection_EtConeCut        = 6.0*GeV
ElectronPreSelection_ApplyJetDRCut    = False
ElectronPreSelection_JetDRCut         = 0.4
ElectronPreSelection_ApplyEtaCrackCut = True
ElectronPreSelection_MinEtaCrack      = 1.37
ElectronPreSelection_MaxEtaCrack      = 1.52
ElectronPreSelection_PtCut            = 30.0*GeV
ElectronPreSelection_EtaCut           = 2.5

MuonPreSelection_ApplyIsHighPtCut  = False
MuonPreSelection_ApplyBestMatchCut = False
MuonPreSelection_Author            = "All" 
MuonPreSelection_ApplyEtConeCut    = False
MuonPreSelection_ConeSize          = 0.2
MuonPreSelection_EtConeCut         = 6.0*GeV
MuonPreSelection_ApplyJetDRCut     = False
MuonPreSelection_JetDRCut          = 0.4
MuonPreSelection_PtCut             = 30.0*GeV
MuonPreSelection_EtaCut            = 2.5

if FullReco:
  PhotonPreSelection_Author = "Photon"
else:
  PhotonPreSelection_Author = "All"

PhotonPreSelection_EmMask         = "None"
PhotonPreSelection_ApplyEtConeCut = False
PhotonPreSelection_ConeSize       = 0.2
PhotonPreSelection_EtConeCut      = 6.0*GeV
PhotonPreSelection_PtCut          = 10.0*GeV
PhotonPreSelection_EtaCut         = 2.5
 
TauJetPreSelection_Author                = "All"
TauJetPreSelection_TauFlag               = "None"
TauJetPreSelection_MinTrackNumber        = 0
TauJetPreSelection_MaxTrackNumber        = 100
TauJetPreSelection_HadronicEtFractionCut = 0.1
TauJetPreSelection_DiscriminantName      = []
TauJetPreSelection_DiscriminantType      = []
TauJetPreSelection_DiscriminantCut       = []
TauJetPreSelection_PtCut                 = 10.0*GeV
TauJetPreSelection_EtaCut                = 2.5

# Object Selection parameters

JetSelection_PtCut  = 15.0*GeV
JetSelection_EtaCut = 5.0

JetTaggingAlgorithm = "IP2D"
JetTaggingWeightCut = 7.05

TaggedJetSelection_TaggingAlgorithm = JetTaggingAlgorithm 
TaggedJetSelection_TaggingWeightCut = JetTaggingWeightCut

TaggedJetSelection_PtCut  = 30.0*GeV
TaggedJetSelection_EtaCut = 2.5

UntaggedJetSelection_TaggingAlgorithm  = JetTaggingAlgorithm
UntaggedJetSelection_TaggingWeightCut  = JetTaggingWeightCut

UntaggedJetSelection_PtCut  = 15.0*GeV
UntaggedJetSelection_EtaCut = 5.0

if FullReco:
  ElectronSelection_Author = "Electron"
  ElectronSelection_EmMask = "Medium"
else:
  ElectronSelection_Author = "All"
  ElectronSelection_EmMask = "None"
  
ElectronSelection_ApplyEtConeCut   = True
ElectronSelection_ConeSize         = 0.2 
ElectronSelection_EtConeCut        = 6.0*GeV
ElectronSelection_ApplyJetDRCut    = False
ElectronSelection_JetDRCut         = 0.2
ElectronSelection_ApplyEtaCrackCut = True
ElectronSelection_MinEtaCrack      = 1.37
ElectronSelection_MaxEtaCrack      = 1.52
ElectronSelection_PtCut            = 30.0*GeV
ElectronSelection_EtaCut           = 2.5

MuonSelection_ApplyIsHighPtCut  = False
MuonSelection_ApplyBestMatchCut = False
MuonSelection_Author            = "All" 
MuonSelection_ApplyEtConeCut    = False
MuonSelection_ConeSize          = 0.2
MuonSelection_EtConeCut         = 6.0*GeV
MuonSelection_ApplyJetDRCut     = False
MuonSelection_JetDRCut          = 0.2
MuonSelection_PtCut             = 30.0*GeV
MuonSelection_EtaCut            = 2.5


# Intermediate Container name assignments
# These names should contain "Photon", "Electron", "Muon", "Tau", "Jet" or "Truth" to be recognized by the algorithms

PreSelectedJetContainerName      = "PreSelectedJets"
PreSelectedElectronContainerName = "PreSelectedElectrons"
PreSelectedMuonContainerName     = "PreSelectedMuons"
PreSelectedPhotonContainerName   = "PreSelectedPhotons"
PreSelectedTauJetContainerName   = "PreSelectedTauJets"

JetPreSelectionLabel      = "JetPreSelection"
ElectronPreSelectionLabel = "ElectronPreSelection"
MuonPreSelectionLabel     = "MuonPreSelection"
PhotonPreSelectionLabel   = "PhotonPreSelection"
TauJetPreSelectionLabel   = "TauJetPreSelection"

OverlapSelectedJetContainerName      = "OverlapSelectedJets"
OverlapSelectedElectronContainerName = "OverlapSelectedElectrons"
OverlapSelectedMuonContainerName     = "OverlapSelectedMuons"
OverlapSelectedPhotonContainerName   = "OverlapSelectedPhotons"
OverlapSelectedTauJetContainerName   = "OverlapSelectedTauJets"

JetOverlapSelectionLabel      = "JetOverlapSelection"
ElectronOverlapSelectionLabel = "ElectronOverlapSelection"
MuonOverlapSelectionLabel     = "MuonOverlapSelection"
PhotonOverlapSelectionLabel   = "PhotonOverlapSelection"
TauJetOverlapSelectionLabel   = "TauJetOverlapSelection"

SelectedJetContainerName          = "SelectedJets"
SelectedTaggedJetContainerName    = "SelectedTaggedJets"
SelectedUntaggedJetContainerName  = "SelectedUntaggedJets"
SelectedElectronContainerName     = "SelectedElectrons"
SelectedMuonContainerName         = "SelectedMuons"
SelectedPhotonContainerName       = "SelectedPhotons"
SelectedTauJetContainerName       = "SelectedTauJets"

JetSelectionLabel         = "JetSelection"
TaggedJetSelectionLabel   = "TaggedJetSelection"
ElectronSelectionLabel    = "ElectronSelection"
MuonSelectionLabel        = "MuonSelection"
PhotonSelectionLabel      = "PhotonSelection"
TauJetSelectionLabel      = "TauJetSelection"

JetSelectionInfoContainerName      = "JetInfo"
ElectronSelectionInfoContainerName = "ElectronInfo"
MuonSelectionInfoContainerName     = "MuonInfo"
PhotonSelectionInfoContainerName   = "PhotonInfo"
TauJetSelectionInfoContainerName   = "TauJetInfo"

# No updating of SelectionInfo by the UntaggedJet selection algorithm 

TriggerDecisionInfoName = "TriggerDecisionInfo"

TopVertexContainerName = "TruthTopVertexParticles"
WVertexContainerName   = "TruthWVertexParticles"
ZVertexContainerName   = "TruthZVertexParticles"


# Object PreSelectionContainer assignments

JetPreSelection_InputContainerName  = JetContainerName
JetPreSelection_OutputContainerName = PreSelectedJetContainerName

JetPreSelection_SelectionInfoContainerName = JetSelectionInfoContainerName
JetPreSelection_SelectionLabel             = JetPreSelectionLabel

ElectronPreSelection_InputContainerName  = ElectronContainerName
ElectronPreSelection_JetContainerName    = PreSelectedJetContainerName
ElectronPreSelection_OutputContainerName = PreSelectedElectronContainerName

ElectronPreSelection_SelectionInfoContainerName = ElectronSelectionInfoContainerName
ElectronPreSelection_SelectionLabel              = ElectronPreSelectionLabel

MuonPreSelection_InputContainerName  = MuonContainerName
MuonPreSelection_JetContainerName    = PreSelectedJetContainerName
MuonPreSelection_OutputContainerName = PreSelectedMuonContainerName

MuonPreSelection_SelectionInfoContainerName = MuonSelectionInfoContainerName
MuonPreSelection_SelectionLabel             = MuonPreSelectionLabel

PhotonPreSelection_InputContainerName  = PhotonContainerName
PhotonPreSelection_OutputContainerName = PreSelectedPhotonContainerName

PhotonPreSelection_SelectionInfoContainerName = PhotonSelectionInfoContainerName
PhotonPreSelection_SelectionLabel             = PhotonPreSelectionLabel

TauJetPreSelection_InputContainerName  = TauJetContainerName
TauJetPreSelection_OutputContainerName = PreSelectedTauJetContainerName 

TauJetPreSelection_SelectionInfoContainerName = TauJetSelectionInfoContainerName
TauJetPreSelection_SelectionLabel             = TauJetPreSelectionLabel


# Overlap Removal parameters
# Overlap Removal is executed on the PreSelected containers
			 
OverlapFilter_RootContainerName      = PreSelectedElectronContainerName
OverlapSelectedElectronContainerName = PreSelectedElectronContainerName

OverlapFilter_InputContainerName         = []
OverlapFilter_OutputContainerName        = []
OverlapFilter_SelectionInfoContainerName = []
OverlapFilter_SelectionLabel             = []
OverlapFilter_FilterSameContainerType    = []
OverlapFilter_DeltaRCut                  = []

OverlapFilter_InputContainerName         += [PreSelectedMuonContainerName]
OverlapFilter_OutputContainerName        += [OverlapSelectedMuonContainerName]
OverlapFilter_SelectionInfoContainerName += [MuonSelectionInfoContainerName]
OverlapFilter_SelectionLabel             += [MuonOverlapSelectionLabel]
OverlapFilter_FilterSameContainerType    += [False]
OverlapFilter_DeltaRCut                  += [0.1]

OverlapFilter_InputContainerName         += [PreSelectedPhotonContainerName]
OverlapFilter_OutputContainerName        += [OverlapSelectedPhotonContainerName]
OverlapFilter_SelectionInfoContainerName += [PhotonSelectionInfoContainerName]
OverlapFilter_SelectionLabel             += [PhotonOverlapSelectionLabel]
OverlapFilter_FilterSameContainerType    += [False]
OverlapFilter_DeltaRCut                  += [0.1]

OverlapFilter_InputContainerName         += [PreSelectedTauJetContainerName]
OverlapFilter_OutputContainerName        += [OverlapSelectedTauJetContainerName]
OverlapFilter_SelectionInfoContainerName += [TauJetSelectionInfoContainerName]
OverlapFilter_SelectionLabel             += [TauJetOverlapSelectionLabel]
OverlapFilter_FilterSameContainerType    += [False]
OverlapFilter_DeltaRCut                  += [0.1]

OverlapFilter_InputContainerName         += [PreSelectedJetContainerName]
OverlapFilter_OutputContainerName        += [OverlapSelectedJetContainerName]
OverlapFilter_SelectionInfoContainerName += [JetSelectionInfoContainerName]
OverlapFilter_SelectionLabel             += [JetOverlapSelectionLabel]
OverlapFilter_FilterSameContainerType    += [False]
OverlapFilter_DeltaRCut                  += [0.1]


# Object Selection Container assignments

JetSelection_InputContainerName  = OverlapSelectedJetContainerName
JetSelection_OutputContainerName = SelectedJetContainerName

JetSelection_SelectionInfoContainerName = JetSelectionInfoContainerName
JetSelection_SelectionLabel             = JetSelectionLabel

TaggedJetSelection_InputContainerName  = OverlapSelectedJetContainerName
TaggedJetSelection_OutputContainerName = SelectedTaggedJetContainerName

TaggedJetSelection_SelectionInfoContainerName = JetSelectionInfoContainerName
TaggedJetSelection_SelectionLabel             = TaggedJetSelectionLabel

UntaggedJetSelection_InputContainerName  = OverlapSelectedJetContainerName
UntaggedJetSelection_OutputContainerName = SelectedUntaggedJetContainerName

ElectronSelection_InputContainerName  = OverlapSelectedElectronContainerName
ElectronSelection_JetContainerName    = OverlapSelectedJetContainerName
ElectronSelection_OutputContainerName = SelectedElectronContainerName

ElectronSelection_SelectionInfoContainerName = ElectronSelectionInfoContainerName
ElectronSelection_SelectionLabel             = ElectronSelectionLabel

MuonSelection_InputContainerName  = OverlapSelectedMuonContainerName
MuonSelection_JetContainerName    = OverlapSelectedJetContainerName
MuonSelection_OutputContainerName = SelectedMuonContainerName

MuonSelection_SelectionInfoContainerName = MuonSelectionInfoContainerName
MuonSelection_SelectionLabel             = MuonSelectionLabel


# TriggerDecisionFilter parameters

TriggerDecisionTool_UseFDRMode                = FDRData
TriggerDecisionFilter_AcceptedChainName       = []
TriggerDecisionFilter_SelectedChainName       = []
TriggerDecisionFilter_TriggerDecisionInfoName = TriggerDecisionInfoName

#if ExecuteChannelPreSelection or ExecuteChannelSelection:
if doTriggerDecision:

  TriggerDecisionFilter_AcceptedChainName += ["EF_e20i"]
  # TriggerDecisionFilter_AcceptedChainName += ["EF_mu20"]


# Event Selection Input Container assignments

CurrentJetContainerName         = SelectedJetContainerName
CurrentTaggedJetContainerName   = SelectedTaggedJetContainerName
CurrentUntaggedJetContainerName = SelectedUntaggedJetContainerName
CurrentElectronContainerName    = SelectedElectronContainerName
CurrentMuonContainerName        = SelectedMuonContainerName
    

# Event Selection parameters

EventSelection_MinNumber     = []
EventSelection_MaxNumber     = []
EventSelection_PtThreshold   = []
EventSelection_EtaThreshold  = []
EventSelection_ContainerName = []

EventSelection_MinSumNumber         = []
EventSelection_MaxSumNumber         = []
EventSelection_FirstPtThreshold     = []
EventSelection_SecondPtThreshold    = []
EventSelection_FirstEtaThreshold    = []
EventSelection_SecondEtaThreshold   = []
EventSelection_FirstContainerName   = []
EventSelection_SecondContainerName  = []

EventSelection_MissingEtThreshold = 0.0*GeV
EventSelection_MissingEtName      = "None"

if ExecutePrimarySelection:

  EventSelection_MissingEtThreshold = 0.0*GeV
  EventSelection_MissingEtName      = "None"

  ### At least one lepton (e or mu) 
  EventSelection_MinSumNumber        += [1]
  EventSelection_MaxSumNumber        += [100]
  EventSelection_FirstPtThreshold    += [30.0*GeV]
  EventSelection_FirstEtaThreshold   += [0.0]
  EventSelection_FirstContainerName  += [CurrentElectronContainerName]
  EventSelection_SecondPtThreshold   += [30.0*GeV]
  EventSelection_SecondEtaThreshold  += [0.0]
  EventSelection_SecondContainerName += [CurrentMuonContainerName]

  ### Exactly two leptons (e or mu)
  # EventSelection_MinNumber     += [2]
  # EventSelection_MaxNumber     += [2]
  # EventSelection_PtThreshold   += [30.0*GeV]
  # EventSelection_EtaThreshold  += [0.0]
  # EventSelection_ContainerName += [CurrentElectronContainerName]
  # 
  # EventSelection_MinNumber     += [0]
  # EventSelection_MaxNumber     += [0]
  # EventSelection_PtThreshold   += [30.0*GeV]
  # EventSelection_EtaThreshold  += [0.0]
  # EventSelection_ContainerName += [CurrentMuonContainerName]

if ExecuteChannelPreSelection:

# Single top channels :
# 1 leptonic W -> 1 lepton + 1 neutrino-missingEt
# 1 central high pt b-jet
# 1 or 2 extra jets

  EventSelection_MissingEtThreshold = 0.0*GeV
  EventSelection_MissingEtName      = "None"
# EventSelection_MissingEtName      = MissingEtName
  
  EventSelection_MinSumNumber        += [1]
  EventSelection_MaxSumNumber        += [100]
  EventSelection_FirstPtThreshold    += [10.0*GeV]
  EventSelection_FirstEtaThreshold   += [0.0]
  EventSelection_FirstContainerName  += [CurrentElectronContainerName]
  EventSelection_SecondPtThreshold   += [10.0*GeV]
  EventSelection_SecondEtaThreshold  += [0.0]
  EventSelection_SecondContainerName += [CurrentMuonContainerName]
  
  EventSelection_MinNumber     += [1]
  EventSelection_MaxNumber     += [100]
  EventSelection_PtThreshold   += [30.0*GeV]
  EventSelection_EtaThreshold  += [0.0]
  EventSelection_ContainerName += [CurrentTaggedJetContainerName]
  
  EventSelection_MinNumber     += [2]
  EventSelection_MaxNumber     += [4]
  EventSelection_PtThreshold   += [15.0*GeV]
  EventSelection_EtaThreshold  += [0.0]
  EventSelection_ContainerName += [CurrentJetContainerName]

  EventSelection_MinNumber     += [1]
  EventSelection_MaxNumber     += [100]
  EventSelection_PtThreshold   += [30.0*GeV]
  EventSelection_EtaThreshold  += [0.0]
  EventSelection_ContainerName += [CurrentJetContainerName]
    

if ExecuteChannelSelection:

  EventSelection_MissingEtThreshold = 20.0*GeV
  EventSelection_MissingEtName      = MissingEtName
  
  EventSelection_MinSumNumber        += [1]
  EventSelection_MaxSumNumber        += [1]
  EventSelection_FirstPtThreshold    += [30.0*GeV]
  EventSelection_FirstEtaThreshold   += [0.0]
  EventSelection_FirstContainerName  += [CurrentElectronContainerName]
  EventSelection_SecondPtThreshold   += [30.0*GeV]
  EventSelection_SecondEtaThreshold  += [0.0]
  EventSelection_SecondContainerName += [CurrentMuonContainerName]
  
  EventSelection_MinSumNumber        += [1]
  EventSelection_MaxSumNumber        += [1]
  EventSelection_FirstPtThreshold    += [10.0*GeV]
  EventSelection_FirstEtaThreshold   += [0.0]
  EventSelection_FirstContainerName  += [CurrentElectronContainerName]
  EventSelection_SecondPtThreshold   += [10.0*GeV]
  EventSelection_SecondEtaThreshold  += [0.0]
  EventSelection_SecondContainerName += [CurrentMuonContainerName]
  
  EventSelection_MinNumber     += [2]
  EventSelection_MaxNumber     += [4]
  EventSelection_PtThreshold   += [15.0*GeV]
  EventSelection_EtaThreshold  += [0.0]
  EventSelection_ContainerName += [CurrentJetContainerName]

  EventSelection_MinNumber     += [1]
  EventSelection_MaxNumber     += [100]
  EventSelection_PtThreshold   += [30.0*GeV]
  EventSelection_EtaThreshold  += [0.0]
  EventSelection_ContainerName += [CurrentJetContainerName]

  if ChannelName == "STt":
  
# t-channel : t q or t_bar q -> W+ b q or W- b_bar q -> l nu b q (leptonic W)
# 1 central high pt b-jet and 1 forward light jet
  
    EventSelection_MinNumber     += [1]
    EventSelection_MaxNumber     += [100]
    EventSelection_PtThreshold   += [50.0*GeV]
    EventSelection_EtaThreshold  += [0.0]
    EventSelection_ContainerName += [CurrentTaggedJetContainerName]
    
    EventSelection_MinNumber     += [1]
    EventSelection_MaxNumber     += [100]
    EventSelection_PtThreshold   += [15.0*GeV]
    EventSelection_EtaThreshold  += [2.5]
    EventSelection_ContainerName += [CurrentUntaggedJetContainerName]
        

  elif ChannelName == "STs":
  
# s-channel : t b_bar or t_bar b -> W+ b b_bar or W- b b_bar -> l nu b b (leptonic W)
# 2 central high pt b-jets and no extra light jets

    EventSelection_MinNumber     += [2]
    EventSelection_MaxNumber     += [100]
    EventSelection_PtThreshold   += [30.0*GeV]
    EventSelection_EtaThreshold  += [0.0]
    EventSelection_ContainerName += [CurrentTaggedJetContainerName]
        
    EventSelection_MinNumber     += [0]
    EventSelection_MaxNumber     += [0]
    EventSelection_PtThreshold   += [15.0*GeV]
    EventSelection_EtaThreshold  += [0.0]
    EventSelection_ContainerName += [CurrentUntaggedJetContainerName]
      

  elif ChannelName == "STWt":
  
# W+t : W- t or W+ t_bar -> W+ W- b or W+ W- b_bar -> l nu q q b (leptonic W + hadronic W)
# 1 central high pt b-jet and 2 light jets
    
    EventSelection_MinNumber     += [1]
    EventSelection_MaxNumber     += [100]
    EventSelection_PtThreshold   += [50.0*GeV]
    EventSelection_EtaThreshold  += [0.0]
    EventSelection_ContainerName += [CurrentTaggedJetContainerName]
  
    EventSelection_MinNumber     += [1]
    EventSelection_MaxNumber     += [100]
    EventSelection_PtThreshold   += [30.0*GeV]
    EventSelection_EtaThreshold  += [0.0]
    EventSelection_ContainerName += [CurrentTaggedJetContainerName]
    
    
# ElectronEtaCrackFilter parameters

ElectronEtaCrackFilter_ElectronContainerName = CurrentElectronContainerName
ElectronEtaCrackFilter_MinEtaCrack           = 1.37
ElectronEtaCrackFilter_MaxEtaCrack           = 1.52
ElectronEtaCrackFilter_MinNumber             = 0
ElectronEtaCrackFilter_MaxNumber             = 0


# Truth Objects Selection parameters

# t -> W_plus + b
# anti_t -> W_moins + anti_b
# t -> g|gamma|Z0 + u|c
# anti_t -> g|gamma|Z0 + anti_u|anti_c

TopVertexFilter_DecayPatterns  = []

TopVertexFilter_DecayPatterns += [" 6 ->  24 +  5"]
TopVertexFilter_DecayPatterns += ["-6 -> -24 + -5"]
TopVertexFilter_DecayPatterns += [" 6 -> 21|22|23 +  2| 4"]
TopVertexFilter_DecayPatterns += ["-6 -> 21|22|23 + -2|-4"]

TopVertexFilter_InputContainerName  = McEventContainerName
TopVertexFilter_OutputContainerName = TopVertexContainerName

# W_plus -> e_plus|mu_plus|tau_plus + nu_e|nu_mu|nu_tau
# W_moins -> e_moins|mu_moins|tau_moins + anti_nu_e|anti_nu_mu|anti_nu_tau
# W_plus -> anti_d|anti_s + u|c
# W_moins -> d|s + anti_u|anti_c

WVertexFilter_DecayPatterns  = []

WVertexFilter_DecayPatterns += [" 24 -> -11|-13|-15 +  12| 14| 16"]
WVertexFilter_DecayPatterns += ["-24 ->  11| 13| 15 + -12|-14|-16"]
WVertexFilter_DecayPatterns += [" 24 -> -1|-3 +  2| 4"]
WVertexFilter_DecayPatterns += ["-24 ->  1| 3 + -2|-4"]

WVertexFilter_InputContainerName  = McEventContainerName
WVertexFilter_OutputContainerName = WVertexContainerName

# Z0 -> e_plus|mu_plus|tau_plus + e_moins|mu_moins|tau_moins
# Z0 -> d|u|s|c|b + anti_d|anti_u|anti_s|anti_c|anti_b

ZVertexFilter_DecayPatterns  = []

ZVertexFilter_DecayPatterns += ["23 -> -11|-13|-15 + 11|13|15"]
ZVertexFilter_DecayPatterns += ["23 -> 1|2|3|4|5 + -1|-2|-3|-4|-5"]

ZVertexFilter_InputContainerName  = McEventContainerName
ZVertexFilter_OutputContainerName = ZVertexContainerName


# Stream and Tree Container assignments
# Recording of the Selected containers after Overlap Removal

CurrentJetContainerName         = SelectedJetContainerName
CurrentTaggedJetContainerName   = SelectedTaggedJetContainerName
CurrentUntaggedJetContainerName = SelectedUntaggedJetContainerName
CurrentElectronContainerName    = SelectedElectronContainerName
CurrentMuonContainerName        = SelectedMuonContainerName
CurrentPhotonContainerName      = OverlapSelectedPhotonContainerName
CurrentTauJetContainerName      = OverlapSelectedTauJetContainerName
  

# Jet and Track Slimming parameters

JetSlimming_JetContainerName = []

if FullReco:
  JetSlimming_JetContainerName += [CurrentJetContainerName]
  JetSlimming_JetContainerName += [CurrentTaggedJetContainerName]
  JetSlimming_JetContainerName += [CurrentUntaggedJetContainerName]
				  
TrackSlimming_TrackParticleContainerName = TrackParticleContainerName
TrackSlimming_TrackPtCut                 = 5.0*GeV


# Container Thinning parameters

ContainerThinning_ContainerName              = []
ContainerThinning_SelectionInfoContainerName = []
ContainerThinning_RequiredSelectionLabel     = []

ContainerThinning_ContainerName              += [ElectronContainerName]
ContainerThinning_SelectionInfoContainerName += [ElectronSelectionInfoContainerName]
ContainerThinning_RequiredSelectionLabel.append([ElectronPreSelectionLabel, ElectronOverlapSelectionLabel, ElectronSelectionLabel])

ContainerThinning_ContainerName              += [MuonContainerName]
ContainerThinning_SelectionInfoContainerName += [MuonSelectionInfoContainerName]
ContainerThinning_RequiredSelectionLabel.append([MuonPreSelectionLabel, MuonOverlapSelectionLabel, MuonSelectionLabel])

ContainerThinning_ContainerName              += [JetContainerName]
ContainerThinning_SelectionInfoContainerName += [JetSelectionInfoContainerName]
ContainerThinning_RequiredSelectionLabel.append([JetPreSelectionLabel, JetOverlapSelectionLabel, JetSelectionLabel])

ContainerThinning_ContainerName              += [TauJetContainerName]
ContainerThinning_SelectionInfoContainerName += [TauJetSelectionInfoContainerName]
ContainerThinning_RequiredSelectionLabel.append([TauJetPreSelectionLabel, TauJetOverlapSelectionLabel, TauJetSelectionLabel])

ContainerThinning_ContainerName              += [PhotonContainerName]
ContainerThinning_SelectionInfoContainerName += [PhotonSelectionInfoContainerName]
ContainerThinning_RequiredSelectionLabel.append([PhotonPreSelectionLabel, PhotonOverlapSelectionLabel, PhotonSelectionLabel])


# Output Stream parameters

ItemList = []

ItemList += ["EventInfo#"+EventInfoName]
ItemList += ["MissingET#"+MissingEtName]
ItemList += ["Rec::TrackParticleContainer#"+TrackParticleContainerName]

if OutputFormat == "D1PD":

  ItemList += ["egammaContainer#"+ElectronContainerName]
  ItemList += ["Analysis::MuonContainer#"+MuonContainerName]
  ItemList += ["JetCollection#"+JetContainerName]
  ItemList += ["egammaContainer#"+PhotonContainerName]
  ItemList += ["Analysis::TauJetContainer#"+TauJetContainerName]

elif OutputFormat == "D2PD":

  ItemList += ["egammaContainer#"+CurrentElectronContainerName]
  ItemList += ["Analysis::MuonContainer#"+CurrentMuonContainerName]
  ItemList += ["JetCollection#"+CurrentJetContainerName]
  ItemList += ["egammaContainer#"+CurrentPhotonContainerName]
  ItemList += ["Analysis::TauJetContainer#"+CurrentTauJetContainerName]

  ItemList += ["JetCollection#"+CurrentTaggedJetContainerName]
  ItemList += ["JetCollection#"+CurrentUntaggedJetContainerName]

if RecordTruth:

  ItemList += ["MissingEtTruth#"+TruthMissingEtName]
  ItemList += ["TruthParticleContainer#"+TruthParticleContainerName]
  ItemList += ["McEventCollection#"+McEventContainerName]
  
ItemList += ["egDetailContainer#edDetailAOD"]

ItemList += ["IOVMetaDataContainer#*"]
ItemList += ["LumiBlockCollection#*"]

  
# Tree parameters

TreeName = "CollectionTree"

TreeMaker_TrackMuonDRCutMin = 0.01
TreeMaker_TrackMuonDRCutMax = 0.45
TreeMaker_TrackMuonPtCut    = 1.0*GeV

TreeMaker_McEventContainerName       = McEventContainerName
TreeMaker_EventInfoName              = EventInfoName
TreeMaker_TrackParticleContainerName = TrackParticleContainerName

TreeMaker_MissingEtName  = []
TreeMaker_MissingEtLabel = []

TreeMaker_MissingEtName  += [MissingEtName]
TreeMaker_MissingEtLabel += ["None"]

TreeMaker_ContainerName   = []
TreeMaker_ContainerLabel  = []
TreeMaker_PtCut           = []

TreeMaker_ContainerName  += [CurrentElectronContainerName]
TreeMaker_ContainerLabel += ["El"]
TreeMaker_PtCut          += [0.0*GeV]
  
TreeMaker_ContainerName  += [CurrentMuonContainerName]
TreeMaker_ContainerLabel += ["Mu"]
TreeMaker_PtCut          += [0.0*GeV]

TreeMaker_ContainerName  += [CurrentJetContainerName]
TreeMaker_ContainerLabel += ["PJet"]
TreeMaker_PtCut          += [0.0*GeV]

TreeMaker_ContainerName  += [CurrentTaggedJetContainerName]
TreeMaker_ContainerLabel += ["BJet"]
TreeMaker_PtCut          += [0.0*GeV]
  
TreeMaker_ContainerName  += [CurrentUntaggedJetContainerName]
TreeMaker_ContainerLabel += ["UJet"]
TreeMaker_PtCut          += [0.0*GeV]

TreeMaker_ContainerName  += [CurrentPhotonContainerName]
TreeMaker_ContainerLabel += ["Ph"]
TreeMaker_PtCut          += [0.0*GeV]
          
TreeMaker_ContainerName  += [CurrentTauJetContainerName]
TreeMaker_ContainerLabel += ["Tau"]
TreeMaker_PtCut          += [0.0*GeV]


# Trigger Tree parameters

TriggerTreeName = "Trigger"

TriggerTreeMaker_TriggerDecisionInfoName  = TriggerDecisionInfoName
TriggerTreeMaker_TriggerDecisionInfoLabel = "Passed"


# Truth Tree parameters
                
if RecordTruth:

  TruthTreeName = "Truth"

  TruthTreeMaker_MissingEtName   = []
  TruthTreeMaker_MissingEtLabel  = []
  
  TruthTreeMaker_MissingEtName  += [TruthMissingEtName]
  TruthTreeMaker_MissingEtLabel += ["None"]
  
  TruthTreeMaker_MissingEtSource  = []

  TruthTreeMaker_MissingEtSource += ["Int"]
  TruthTreeMaker_MissingEtSource += ["NonInt"]
  TruthTreeMaker_MissingEtSource += ["IntCentral"]
  TruthTreeMaker_MissingEtSource += ["IntFwd"]
  TruthTreeMaker_MissingEtSource += ["IntOutCover"]
  TruthTreeMaker_MissingEtSource += ["Muons"]
  
  TruthTreeMaker_McEventContainerName = McEventContainerName

  TruthTreeMaker_ContainerName  = []
  TruthTreeMaker_ContainerLabel = []
  
  TruthTreeMaker_ContainerName  += [TopVertexContainerName]
  TruthTreeMaker_ContainerLabel += ["Top"]
  
  TruthTreeMaker_ContainerName  += [WVertexContainerName]
  TruthTreeMaker_ContainerLabel += ["W"]
  
  TruthTreeMaker_ContainerName  += [WVertexContainerName]
  TruthTreeMaker_ContainerLabel += ["Z"]
  
  
# Ntuple parameters

NtupleName = "SingleTop"

NtupleMaker_EventInfoName            = EventInfoName
NtupleMaker_MissingEtName            = MissingEtName
NtupleMaker_ElectronContainerName    = CurrentElectronContainerName
NtupleMaker_MuonContainerName        = CurrentMuonContainerName
NtupleMaker_TaggedJetContainerName   = CurrentTaggedJetContainerName
NtupleMaker_UntaggedJetContainerName = CurrentUntaggedJetContainerName
 

# Sequence execution
			
include("exeSingleTopDPDMaker.py")
