from AthenaCommon.AppMgr import theApp

theApp.Dlls += ["SingleTopDPDMaker"]
theApp.Dlls += ["SingleTopDPDMakerDict"]

theApp.EvtMax = NbEventMax

from AthenaCommon.AlgSequence import AlgSequence

Sequence = AlgSequence()

from AthenaCommon.AlgSequence import AthSequencer

Sequencer = AthSequencer("SingleTopDPDMakerSequencer")

AthSequencer.StopOverride = False

Sequence += Sequencer

from SingleTopDPDMaker.SingleTopDPDMakerConf import PhotonSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import ElectronSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import MuonSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import TauJetSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import JetSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import TaggedJetSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import UntaggedJetSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import EventFilter
from SingleTopDPDMaker.SingleTopDPDMakerConf import OverlapFilter
from SingleTopDPDMaker.SingleTopDPDMakerConf import TreeMaker

if ExecuteSelection:

  JetSelection         = JetSelection("JetSelection")
  TaggedJetSelection   = TaggedJetSelection("TaggedJetSelection")
  UntaggedJetSelection = UntaggedJetSelection("UntaggedJetSelection")
  ElectronSelection    = ElectronSelection("ElectronSelection")
  MuonSelection        = MuonSelection("MuonSelection")
  
  Sequencer += JetSelection
  Sequencer += TaggedJetSelection
  Sequencer += UntaggedJetSelection
  Sequencer += ElectronSelection
  Sequencer += MuonSelection
  
  if ExecutePhotonSelection:
    PhotonSelection = PhotonSelection("PhotonSelection")
    Sequencer += PhotonSelection
    
  if ExecuteTauJetSelection:
    TauJetSelection = TauJetSelection("TauJetSelection")
    Sequencer += TauJetSelection
  
  if ExecuteOverlapRemoval:
    OverlapFilter = OverlapFilter("OverlapFilter")
    Sequencer += OverlapFilter
    
  EventFilter = EventFilter("EventFilter")
  Sequencer += EventFilter
  
TreeMaker = TreeMaker("TreeMaker")
Sequencer += TreeMaker

from AthenaCommon.AppMgr import ServiceMgr
import AthenaPoolCnvSvc.ReadAthenaPool

ServiceMgr.EventSelector.InputCollections = InputCollections
ServiceMgr.EventSelector.SkipEvents       = NbEventSkip

from GaudiSvc.GaudiSvcConf import THistSvc

ServiceMgr += THistSvc()

ServiceMgr.THistSvc.Output = ["AANT DATAFILE='"+OutputFileName+"' OPT='recreate'"]


# OutputLevel parameters

if ExecuteSelection:

  ElectronSelection.OutputLevel    = INFO
  MuonSelection.OutputLevel        = INFO
  JetSelection.OutputLevel         = INFO
  TaggedJetSelection.OutputLevel   = INFO
  UntaggedJetSelection.OutputLevel = INFO
  EventFilter.OutputLevel          = INFO
  
  if ExecutePhotonSelection:
    PhotonSelection.OutputLevel = INFO
    
  if ExecuteTauJetSelection:
    TauJetSelection.OutputLevel = INFO

  if ExecuteOverlapRemoval:
    OverlapFilter.OutputLevel = INFO
  
TreeMaker.OutputLevel = INFO

AthenaEventLoopMgr = Service("AthenaEventLoopMgr")

AthenaEventLoopMgr.OutputLevel = ERROR
MessageSvc.OutputLevel         = ERROR
StatusCodeSvc.OutputLevel      = ERROR


# Selection parameters

if ExecuteSelection:

  JetSelection.InputContainerName  = JetSelection_InputContainerName
  JetSelection.OutputContainerName = JetSelection_OutputContainerName
  
  JetSelection.MinPtCut = JetSelection_MinPtCut
  JetSelection.MaxPtCut = JetSelection_MaxPtCut
  JetSelection.EtaCut   = JetSelection_EtaCut
  
  TaggedJetSelection.InputContainerName  = TaggedJetSelection_InputContainerName
  TaggedJetSelection.OutputContainerName = TaggedJetSelection_OutputContainerName
  
  TaggedJetSelection.MinPtCut         = TaggedJetSelection_MinPtCut
  TaggedJetSelection.MaxPtCut         = TaggedJetSelection_MaxPtCut
  TaggedJetSelection.EtaCut           = TaggedJetSelection_EtaCut
  TaggedJetSelection.TaggingAlgorithm = TaggedJetSelection_TaggingAlgorithm
  TaggedJetSelection.TaggingWeightCut = TaggedJetSelection_TaggingWeightCut
  
  UntaggedJetSelection.InputContainerName  = UntaggedJetSelection_InputContainerName
  UntaggedJetSelection.OutputContainerName = UntaggedJetSelection_OutputContainerName
  
  UntaggedJetSelection.MinPtCut         = UntaggedJetSelection_MinPtCut
  UntaggedJetSelection.MaxPtCut         = UntaggedJetSelection_MaxPtCut
  UntaggedJetSelection.EtaCut           = UntaggedJetSelection_EtaCut
  UntaggedJetSelection.TaggingAlgorithm = UntaggedJetSelection_TaggingAlgorithm
  UntaggedJetSelection.TaggingWeightCut = UntaggedJetSelection_TaggingWeightCut

  ElectronSelection.InputContainerName  = ElectronSelection_InputContainerName
  ElectronSelection.OutputContainerName = ElectronSelection_OutputContainerName
  ElectronSelection.JetContainerName    = ElectronSelection_JetContainerName
  
  ElectronSelection.EmMask         = ElectronSelection_EmMask
  ElectronSelection.Author         = ElectronSelection_Author 
  ElectronSelection.MinPtCut       = ElectronSelection_MinPtCut
  ElectronSelection.MaxPtCut       = ElectronSelection_MaxPtCut
  ElectronSelection.EtaCut         = ElectronSelection_EtaCut
  ElectronSelection.ApplyEtConeCut = ElectronSelection_ApplyEtConeCut
  ElectronSelection.ConeSize       = ElectronSelection_ConeSize
  ElectronSelection.EtConeCut      = ElectronSelection_EtConeCut
  
  MuonSelection.InputContainerName  = MuonSelection_InputContainerName  
  MuonSelection.OutputContainerName = MuonSelection_OutputContainerName
  MuonSelection.JetContainerName    = MuonSelection_JetContainerName
  
  MuonSelection.Author         = MuonSelection_Author
  MuonSelection.MinPtCut       = MuonSelection_MinPtCut
  MuonSelection.MaxPtCut       = MuonSelection_MaxPtCut
  MuonSelection.EtaCut         = MuonSelection_EtaCut
  MuonSelection.ApplyEtConeCut = MuonSelection_ApplyEtConeCut
  MuonSelection.ConeSize       = MuonSelection_ConeSize
  MuonSelection.EtConeCut      = MuonSelection_EtConeCut
  MuonSelection.ApplyJetDRCut  = MuonSelection_ApplyJetDRCut
  MuonSelection.JetDRCut       = MuonSelection_JetDRCut
  
  if ExecutePhotonSelection:

    PhotonSelection.InputContainerName  = PhotonSelection_InputContainerName
    PhotonSelection.OutputContainerName = PhotonSelection_OutputContainerName
  
    PhotonSelection.EmMask         = PhotonSelection_EmMask
    PhotonSelection.Author         = PhotonSelection_Author 
    PhotonSelection.MinPtCut       = PhotonSelection_MinPtCut
    PhotonSelection.MaxPtCut       = PhotonSelection_MaxPtCut
    PhotonSelection.EtaCut         = PhotonSelection_EtaCut
    PhotonSelection.ApplyEtConeCut = PhotonSelection_ApplyEtConeCut
    PhotonSelection.ConeSize       = PhotonSelection_ConeSize
    PhotonSelection.EtConeCut      = PhotonSelection_EtConeCut
  
  if ExecuteTauJetSelection:
  
    TauJetSelection.InputContainerName  = TauJetSelection_InputContainerName
    TauJetSelection.OutputContainerName = TauJetSelection_OutputContainerName
  
    TauJetSelection.MinPtCut = TauJetSelection_MinPtCut
    TauJetSelection.MaxPtCut = TauJetSelection_MaxPtCut
    TauJetSelection.EtaCut   = TauJetSelection_EtaCut
    

# OverlapFilter parameters

if ExecuteSelection:

  if ExecuteOverlapRemoval:

    OverlapFilter.RootContainerName       = OverlapFilter_RootContainerName
    OverlapFilter.InputContainerName      = OverlapFilter_InputContainerName
    OverlapFilter.OutputContainerName     = OverlapFilter_OutputContainerName
    OverlapFilter.FilterSameContainerType = OverlapFilter_FilterSameContainerType
    OverlapFilter.DeltaRCut               = OverlapFilter_DeltaRCut
    
    
# EventFilter parameters
    
if ExecuteSelection: 

  EventFilter.MissingEtName       = EventFilter_MissingEtName
  EventFilter.ContainerName       = EventFilter_ContainerName
  EventFilter.FirstContainerName  = EventFilter_FirstContainerName
  EventFilter.SecondContainerName = EventFilter_SecondContainerName
  
  EventFilter.MissingEtCut = EventFilter_MissingEtCut
  EventFilter.MinNumber    = EventFilter_MinNumber
  EventFilter.MaxNumber    = EventFilter_MaxNumber
  EventFilter.MinSumNumber = EventFilter_MinSumNumber
  EventFilter.MaxSumNumber = EventFilter_MaxSumNumber


# TreeMaker parameters

TreeMaker.TreeName                   = TreeName

TreeMaker.EventInfoName              = TreeMaker_EventInfoName
TreeMaker.MissingEtName              = TreeMaker_MissingEtName
TreeMaker.TrackParticleContainerName = TreeMaker_TrackParticleContainerName
TreeMaker.ContainerName              = TreeMaker_ContainerName
TreeMaker.ContainerLabel             = TreeMaker_ContainerLabel

TreeMaker.TrackMuonDRCutMin          = TreeMaker_TrackMuonDRCutMin
TreeMaker.TrackMuonDRCutMax          = TreeMaker_TrackMuonDRCutMax
TreeMaker.TrackMuonPtCut             = TreeMaker_TrackMuonPtCut
