from AthenaCommon.AppMgr import theApp

theApp.Dlls += ["SingleTopDPDMaker"]
theApp.Dlls += ["SingleTopDPDMakerDict"]

theApp.EvtMax = NbEventMax

from AthenaCommon.AlgSequence import AlgSequence

Sequence = AlgSequence()

from AthenaCommon.AlgSequence import AthSequencer

Sequencer = AthSequencer("SingleTopDPDMakerSequencer")

AthSequencer.StopOverride = False

Sequence += Sequencer

from SingleTopDPDMaker.SingleTopDPDMakerConf import ElectronSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import MuonSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import JetSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import TaggedJetSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import UntaggedJetSelection
from SingleTopDPDMaker.SingleTopDPDMakerConf import EventFilter
from SingleTopDPDMaker.SingleTopDPDMakerConf import OverlapFilter
from SingleTopDPDMaker.SingleTopDPDMakerConf import TreeMaker

StdPtJetSelection = JetSelection("StdPtJetSelection")
LowPtJetSelection = JetSelection("LowPtJetSelection")

Sequencer += StdPtJetSelection
Sequencer += LowPtJetSelection

StdPtTaggedJetSelection  = TaggedJetSelection("StdPtTaggedJetSelection")
HighPtTaggedJetSelection = TaggedJetSelection("HighPtTaggedJetSelection")
LowPtTaggedJetSelection  = TaggedJetSelection("LowPtTaggedJetSelection")
  
Sequencer += StdPtTaggedJetSelection
Sequencer += HighPtTaggedJetSelection
Sequencer += LowPtTaggedJetSelection

StdPtUntaggedJetSelection = UntaggedJetSelection("StdPtUntaggedJetSelection")
LowPtUntaggedJetSelection = UntaggedJetSelection("LowPtUntaggedJetSelection")

Sequencer += StdPtUntaggedJetSelection
Sequencer += LowPtUntaggedJetSelection
    
StdPtElectronSelection = ElectronSelection("StdPtElectronSelection")
LowPtElectronSelection = ElectronSelection("LowPtElectronSelection")

Sequencer += StdPtElectronSelection
Sequencer += LowPtElectronSelection

StdPtMuonSelection     = MuonSelection("StdPtMuonSelection")
LowPtMuonSelection     = MuonSelection("LowPtMuonSelection")
  
Sequencer += StdPtMuonSelection
Sequencer += LowPtMuonSelection
        
PreSelection = EventFilter("PreSelection")
Sequencer += PreSelection

ChannelSelection = EventFilter("ChannelSelection")
Sequencer += ChannelSelection

TreeMaker = TreeMaker("TreeMaker")
Sequencer += TreeMaker
  
from AthenaCommon.AppMgr import ServiceMgr
import AthenaPoolCnvSvc.ReadAthenaPool

ServiceMgr.EventSelector.InputCollections = InputCollections
ServiceMgr.EventSelector.SkipEvents       = NbEventSkip

from GaudiSvc.GaudiSvcConf import THistSvc

ServiceMgr += THistSvc()

ServiceMgr.THistSvc.Output = ["AANT DATAFILE='"+OutputFileName+"' OPT='recreate'"]


# OutputLevel parameters

StdPtJetSelection.OutputLevel         = INFO
LowPtJetSelection.OutputLevel         = INFO

StdPtTaggedJetSelection.OutputLevel   = INFO
HighPtTaggedJetSelection.OutputLevel  = INFO
LowPtTaggedJetSelection.OutputLevel   = INFO

StdPtUntaggedJetSelection.OutputLevel = INFO
LowPtUntaggedJetSelection.OutputLevel = INFO

StdPtElectronSelection.OutputLevel    = INFO
LowPtElectronSelection.OutputLevel    = INFO

StdPtMuonSelection.OutputLevel        = INFO
LowPtMuonSelection.OutputLevel        = INFO

PreSelection.OutputLevel              = INFO
ChannelSelection.OutputLevel          = INFO

TreeMaker.OutputLevel                 = INFO

AthenaEventLoopMgr = Service("AthenaEventLoopMgr")

AthenaEventLoopMgr.OutputLevel = ERROR
MessageSvc.OutputLevel         = ERROR
StatusCodeSvc.OutputLevel      = ERROR


# Selection parameters

StdPtJetSelection.InputContainerName  = StdPtJetSelection_InputContainerName
StdPtJetSelection.OutputContainerName = StdPtJetSelection_OutputContainerName
  
StdPtJetSelection.MinPtCut = StdPtJetSelection_MinPtCut
StdPtJetSelection.MaxPtCut = StdPtJetSelection_MaxPtCut
StdPtJetSelection.EtaCut   = StdPtJetSelection_EtaCut

LowPtJetSelection.InputContainerName  = LowPtJetSelection_InputContainerName
LowPtJetSelection.OutputContainerName = LowPtJetSelection_OutputContainerName
  
LowPtJetSelection.MinPtCut = LowPtJetSelection_MinPtCut
LowPtJetSelection.MaxPtCut = LowPtJetSelection_MaxPtCut
LowPtJetSelection.EtaCut   = LowPtJetSelection_EtaCut

StdPtTaggedJetSelection.InputContainerName  = StdPtTaggedJetSelection_InputContainerName
StdPtTaggedJetSelection.OutputContainerName = StdPtTaggedJetSelection_OutputContainerName
  
StdPtTaggedJetSelection.MinPtCut         = StdPtTaggedJetSelection_MinPtCut
StdPtTaggedJetSelection.MaxPtCut         = StdPtTaggedJetSelection_MaxPtCut
StdPtTaggedJetSelection.EtaCut           = StdPtTaggedJetSelection_EtaCut
StdPtTaggedJetSelection.TaggingAlgorithm = StdPtTaggedJetSelection_TaggingAlgorithm
StdPtTaggedJetSelection.TaggingWeightCut = StdPtTaggedJetSelection_TaggingWeightCut

HighPtTaggedJetSelection.InputContainerName  = HighPtTaggedJetSelection_InputContainerName
HighPtTaggedJetSelection.OutputContainerName = HighPtTaggedJetSelection_OutputContainerName
  
HighPtTaggedJetSelection.MinPtCut         = HighPtTaggedJetSelection_MinPtCut
HighPtTaggedJetSelection.MaxPtCut         = HighPtTaggedJetSelection_MaxPtCut
HighPtTaggedJetSelection.EtaCut           = HighPtTaggedJetSelection_EtaCut
HighPtTaggedJetSelection.TaggingAlgorithm = HighPtTaggedJetSelection_TaggingAlgorithm
HighPtTaggedJetSelection.TaggingWeightCut = HighPtTaggedJetSelection_TaggingWeightCut

LowPtTaggedJetSelection.InputContainerName  = LowPtTaggedJetSelection_InputContainerName
LowPtTaggedJetSelection.OutputContainerName = LowPtTaggedJetSelection_OutputContainerName
  
LowPtTaggedJetSelection.MinPtCut         = LowPtTaggedJetSelection_MinPtCut
LowPtTaggedJetSelection.MaxPtCut         = LowPtTaggedJetSelection_MaxPtCut
LowPtTaggedJetSelection.EtaCut           = LowPtTaggedJetSelection_EtaCut
LowPtTaggedJetSelection.TaggingAlgorithm = LowPtTaggedJetSelection_TaggingAlgorithm
LowPtTaggedJetSelection.TaggingWeightCut = LowPtTaggedJetSelection_TaggingWeightCut

StdPtUntaggedJetSelection.InputContainerName  = StdPtUntaggedJetSelection_InputContainerName
StdPtUntaggedJetSelection.OutputContainerName = StdPtUntaggedJetSelection_OutputContainerName

StdPtUntaggedJetSelection.MinPtCut         = StdPtUntaggedJetSelection_MinPtCut
StdPtUntaggedJetSelection.MaxPtCut         = StdPtUntaggedJetSelection_MaxPtCut
StdPtUntaggedJetSelection.EtaCut           = StdPtUntaggedJetSelection_EtaCut
StdPtUntaggedJetSelection.TaggingAlgorithm = StdPtUntaggedJetSelection_TaggingAlgorithm
StdPtUntaggedJetSelection.TaggingWeightCut = StdPtUntaggedJetSelection_TaggingWeightCut

LowPtUntaggedJetSelection.InputContainerName  = LowPtUntaggedJetSelection_InputContainerName
LowPtUntaggedJetSelection.OutputContainerName = LowPtUntaggedJetSelection_OutputContainerName

LowPtUntaggedJetSelection.MinPtCut         = LowPtUntaggedJetSelection_MinPtCut
LowPtUntaggedJetSelection.MaxPtCut         = LowPtUntaggedJetSelection_MaxPtCut
LowPtUntaggedJetSelection.EtaCut           = LowPtUntaggedJetSelection_EtaCut
LowPtUntaggedJetSelection.TaggingAlgorithm = LowPtUntaggedJetSelection_TaggingAlgorithm
LowPtUntaggedJetSelection.TaggingWeightCut = LowPtUntaggedJetSelection_TaggingWeightCut

StdPtElectronSelection.InputContainerName  = StdPtElectronSelection_InputContainerName
StdPtElectronSelection.OutputContainerName = StdPtElectronSelection_OutputContainerName
StdPtElectronSelection.JetContainerName    = StdPtElectronSelection_JetContainerName
  
StdPtElectronSelection.EmMask         = StdPtElectronSelection_EmMask
StdPtElectronSelection.Author         = StdPtElectronSelection_Author 
StdPtElectronSelection.MinPtCut       = StdPtElectronSelection_MinPtCut
StdPtElectronSelection.MaxPtCut       = StdPtElectronSelection_MaxPtCut
StdPtElectronSelection.EtaCut         = StdPtElectronSelection_EtaCut
StdPtElectronSelection.ApplyEtConeCut = StdPtElectronSelection_ApplyEtConeCut
StdPtElectronSelection.ConeSize       = StdPtElectronSelection_ConeSize
StdPtElectronSelection.EtConeCut      = StdPtElectronSelection_EtConeCut

LowPtElectronSelection.InputContainerName  = LowPtElectronSelection_InputContainerName
LowPtElectronSelection.OutputContainerName = LowPtElectronSelection_OutputContainerName
LowPtElectronSelection.JetContainerName    = LowPtElectronSelection_JetContainerName
  
LowPtElectronSelection.EmMask         = LowPtElectronSelection_EmMask
LowPtElectronSelection.Author         = LowPtElectronSelection_Author 
LowPtElectronSelection.MinPtCut       = LowPtElectronSelection_MinPtCut
LowPtElectronSelection.MaxPtCut       = LowPtElectronSelection_MaxPtCut
LowPtElectronSelection.EtaCut         = LowPtElectronSelection_EtaCut
LowPtElectronSelection.ApplyEtConeCut = LowPtElectronSelection_ApplyEtConeCut
LowPtElectronSelection.ConeSize       = LowPtElectronSelection_ConeSize
LowPtElectronSelection.EtConeCut      = LowPtElectronSelection_EtConeCut
  
StdPtMuonSelection.InputContainerName  = StdPtMuonSelection_InputContainerName  
StdPtMuonSelection.OutputContainerName = StdPtMuonSelection_OutputContainerName
StdPtMuonSelection.JetContainerName    = StdPtMuonSelection_JetContainerName
  
StdPtMuonSelection.Author         = StdPtMuonSelection_Author
StdPtMuonSelection.MinPtCut       = StdPtMuonSelection_MinPtCut
StdPtMuonSelection.MaxPtCut       = StdPtMuonSelection_MaxPtCut
StdPtMuonSelection.EtaCut         = StdPtMuonSelection_EtaCut
StdPtMuonSelection.ApplyEtConeCut = StdPtMuonSelection_ApplyEtConeCut
StdPtMuonSelection.ConeSize       = StdPtMuonSelection_ConeSize
StdPtMuonSelection.EtConeCut      = StdPtMuonSelection_EtConeCut
StdPtMuonSelection.ApplyJetDRCut  = StdPtMuonSelection_ApplyJetDRCut
StdPtMuonSelection.JetDRCut       = StdPtMuonSelection_JetDRCut

LowPtMuonSelection.InputContainerName  = LowPtMuonSelection_InputContainerName  
LowPtMuonSelection.OutputContainerName = LowPtMuonSelection_OutputContainerName
LowPtMuonSelection.JetContainerName    = LowPtMuonSelection_JetContainerName
  
LowPtMuonSelection.Author         = LowPtMuonSelection_Author
LowPtMuonSelection.MinPtCut       = LowPtMuonSelection_MinPtCut
LowPtMuonSelection.MaxPtCut       = LowPtMuonSelection_MaxPtCut
LowPtMuonSelection.EtaCut         = LowPtMuonSelection_EtaCut
LowPtMuonSelection.ApplyEtConeCut = LowPtMuonSelection_ApplyEtConeCut
LowPtMuonSelection.ConeSize       = LowPtMuonSelection_ConeSize
LowPtMuonSelection.EtConeCut      = LowPtMuonSelection_EtConeCut
LowPtMuonSelection.ApplyJetDRCut  = LowPtMuonSelection_ApplyJetDRCut
LowPtMuonSelection.JetDRCut       = LowPtMuonSelection_JetDRCut
    

# EventFilter parameters

PreSelection.MissingEtName       = PreSelection_MissingEtName
PreSelection.ContainerName       = PreSelection_ContainerName
PreSelection.FirstContainerName  = PreSelection_FirstContainerName
PreSelection.SecondContainerName = PreSelection_SecondContainerName
  
PreSelection.MissingEtCut = PreSelection_MissingEtCut
PreSelection.MinNumber    = PreSelection_MinNumber
PreSelection.MaxNumber    = PreSelection_MaxNumber
PreSelection.MinSumNumber = PreSelection_MinSumNumber
PreSelection.MaxSumNumber = PreSelection_MaxSumNumber
  
ChannelSelection.MissingEtName       = ChannelSelection_MissingEtName
ChannelSelection.ContainerName       = ChannelSelection_ContainerName
ChannelSelection.FirstContainerName  = ChannelSelection_FirstContainerName
ChannelSelection.SecondContainerName = ChannelSelection_SecondContainerName
  
ChannelSelection.MissingEtCut = ChannelSelection_MissingEtCut
ChannelSelection.MinNumber    = ChannelSelection_MinNumber
ChannelSelection.MaxNumber    = ChannelSelection_MaxNumber
ChannelSelection.MinSumNumber = ChannelSelection_MinSumNumber
ChannelSelection.MaxSumNumber = ChannelSelection_MaxSumNumber


# TreeMaker parameters

TreeMaker.TreeName                   = TreeName

TreeMaker.EventInfoName              = TreeMaker_EventInfoName
TreeMaker.MissingEtName              = TreeMaker_MissingEtName
TreeMaker.TrackParticleContainerName = TreeMaker_TrackParticleContainerName
TreeMaker.ContainerName              = TreeMaker_ContainerName
TreeMaker.ContainerLabel             = TreeMaker_ContainerLabel

TreeMaker.TrackMuonDRCutMin          = TreeMaker_TrackMuonDRCutMin
TreeMaker.TrackMuonDRCutMax          = TreeMaker_TrackMuonDRCutMax
TreeMaker.TrackMuonPtCut             = TreeMaker_TrackMuonPtCut
