# B Tagging standalone
# (taken from BTagging_standAlone.py in BTagging-00-05-25)

DetDescrVersion = 'ATLAS-CSC-01-02-00'

myjets = InitialJetContainerName
IDSimulationOnly = False
doTruth = False

include ("RecExCommon/RecExCommon_flags.py")
if IDSimulationOnly:
  DetFlags.Calo_setOff()
  DetFlags.Muon_setOff()
include ("RecExCond/AllDet_detDescr.py")
include( "IOVDbSvc/IOVRecExCommon.py" )
include( "AthenaPoolCnvSvc/ReadAthenaPool_jobOptions.py" )

from GaudiAlg.GaudiAlgConf import EventCounter
Sequence += EventCounter(Frequency=100)

from ParticleBuilderOptions.AODFlags import AODFlags
AODFlags.TruthParticleJet = False
if not 'BTaggingFlags' in dir():
  from BTagging.BTaggingFlags import BTaggingFlags
BTaggingFlags.Runmodus                         = "analysis"
BTaggingFlags.TrackParticleCollectionName      = "TrackParticleCandidate"
BTaggingFlags.TrackParticleTruthCollectionName = "TrackParticleTruthCollection"
BTaggingFlags.PrimaryVertexCollectionName      = "VxPrimaryCandidate"
BTaggingFlags.PoolInputType                    = "AOD"
BTaggingFlags.Jets                             = myjets[:]
BTaggingFlags.JetsWithInfoPlus                 = myjets[:]
BTaggingFlags.OutputLevel                      = INFO
#BTaggingFlags.OutputLevel                      = DEBUG
if IDSimulationOnly:
  BTaggingFlags.SoftEl = False
  BTaggingFlags.SoftMu = False
include( "BTagging/BTagging_jobOptions.py" )
# recreate GEN_AOD when reading ESD (uncomment if needed by analysis downstream):
#include("McParticleAlgs/TruthParticleBuilder_jobOptions.py")

print "List of all top algorithms"
print Sequence
