from AthenaCommon.AppMgr import theApp

theApp.Dlls += ["SingleTopDPDMaker"]
theApp.Dlls += ["SingleTopDPDMakerDict"]

theApp.EvtMax = NbEventMax

from AthenaCommon.AppMgr import ServiceMgr
import AthenaPoolCnvSvc.ReadAthenaPool

ServiceMgr.EventSelector.InputCollections = InputCollections
ServiceMgr.EventSelector.SkipEvents       = NbEventSkip

from AthenaCommon.AlgSequence import AlgSequence
from AthenaCommon.AlgSequence import AthSequencer

Sequence  = AlgSequence()
Sequencer = AthSequencer("SingleTopDPDMakerSequencer")
Sequence += Sequencer

AthSequencer.StopOverride = False

from TrigDecision.TrigDecisionConfig import TrigDecisionTool
  
TriggerDecisionTool = TrigDecisionTool()
ToolSvc += TriggerDecisionTool

if redoBTagging:
  include("doBTaggingStandalone.py")

from SingleTopDPDMaker.TriggerConfigurationGetter import TriggerConfigurationGetter

TriggerConfigurationGetter = TriggerConfigurationGetter()
  
from SingleTopDPDMaker.SingleTopDPDMakerConf import *

JetPreSelection      = JetSelection("JetPreSelection")
ElectronPreSelection = ElectronSelection("ElectronPreSelection")
MuonPreSelection     = MuonSelection("MuonPreSelection")
PhotonPreSelection   = PhotonSelection("PhotonPreSelection")
TauJetPreSelection   = TauJetSelection("TauJetPreSelection")
  
Sequencer += JetPreSelection
Sequencer += ElectronPreSelection
Sequencer += MuonPreSelection
Sequencer += PhotonPreSelection
Sequencer += TauJetPreSelection
  
OverlapFilter = OverlapFilter("OverlapFilter")
Sequencer += OverlapFilter

JetSelection         = JetSelection("JetSelection")
TaggedJetSelection   = TaggedJetSelection("TaggedJetSelection")
UntaggedJetSelection = UntaggedJetSelection("UntaggedJetSelection")
ElectronSelection    = ElectronSelection("ElectronSelection")
MuonSelection        = MuonSelection("MuonSelection")

Sequencer += JetSelection
Sequencer += TaggedJetSelection
Sequencer += UntaggedJetSelection
Sequencer += ElectronSelection
Sequencer += MuonSelection

TriggerDecisionFilter = TriggerDecisionFilter("TriggerDecisionFilter")
Sequencer += TriggerDecisionFilter
      
EventSelection = EventFilter("EventSelection")
Sequencer += EventSelection

if ExecuteChannelPreSelection or ExecuteChannelSelection:

  ElectronEtaCrackFilter = ElectronEtaCrackFilter("ElectronEtaCrackFilter")
  Sequencer += ElectronEtaCrackFilter
        
if SelectTruth:
  
  TopVertexFilter = TruthVertexFilter("TopVertexFilter")
  WVertexFilter   = TruthVertexFilter("WVertexFilter")
  ZVertexFilter   = TruthVertexFilter("ZVertexFilter")
  
  Sequencer += TopVertexFilter
  Sequencer += WVertexFilter
  Sequencer += ZVertexFilter
        
if OutputFormat == "D1PD" or OutputFormat == "D2PD":

  from OutputStreamAthenaPool.MultipleStreamManager import MSMgr

  Stream = MSMgr.NewStream("SingleTopDPDMaker")

  AlgorithmList  = []
  AlgorithmList += ["TriggerDecisionFilter"]
  AlgorithmList += ["EventSelection"]
  
  if ExecuteChannelPreSelection or ExecuteChannelSelection:
    AlgorithmList += ["ElectronEtaCrackFilter"]
    
  Stream.RequireAlgs(AlgorithmList)

  Stream.SetOutputFileName(OutputFileName)
  Stream.ForceRead = TRUE
  Stream.AddItem(ItemList)

  if ApplySlimming:
  
    JetSlimming     = JetSlimming("JetSlimming")
    TrackSlimming   = TrackSlimming("TrackSlimming")
    TriggerSlimming = TriggerSlimming("TriggerSlimming")

    Sequencer += JetSlimming
    Sequencer += TrackSlimming
    Sequencer += TriggerSlimming
    
  if OutputFormat == "D1PD" and ApplyThinning:
  
    from AthenaServices.Configurables import createThinningSvc
    
    ServiceMgr += createThinningSvc(svcName = "ThinningSvc", outStreams = [Sequence.__getattr__("SingleTopDPDMaker")])
  
    ContainerThinning = ContainerThinning("ContainerThinning")
    Sequencer += ContainerThinning
      
if OutputFormat == "D3PD":
        
  TreeMaker = TreeMaker("TreeMaker")
  Sequencer += TreeMaker
  
  TriggerTreeMaker = TriggerTreeMaker("TriggerTreeMaker")
  Sequencer += TriggerTreeMaker

  if RecordTruth:

    TruthTreeMaker = TruthTreeMaker("TruthTreeMaker")
    Sequencer += TruthTreeMaker

  from GaudiSvc.GaudiSvcConf import THistSvc

  ServiceMgr += THistSvc()

  ServiceMgr.THistSvc.Output = ["AANT DATAFILE='"+OutputFileName+"' OPT='recreate'"]
  
if OutputFormat == "D4PD":
        
  NtupleMaker = NtupleMaker("NtupleMaker")
  Sequencer += NtupleMaker


# OutputLevel parameters

AthenaEventLoopMgr = Service("AthenaEventLoopMgr")

AthenaEventLoopMgr.OutputLevel = ERROR
MessageSvc.OutputLevel         = ERROR
StatusCodeSvc.OutputLevel      = ERROR

JetPreSelection.OutputLevel       = INFO
ElectronPreSelection.OutputLevel  = INFO
MuonPreSelection.OutputLevel      = INFO
PhotonPreSelection.OutputLevel    = INFO
TauJetPreSelection.OutputLevel    = INFO
    
OverlapFilter.OutputLevel         = INFO

JetSelection.OutputLevel          = INFO
TaggedJetSelection.OutputLevel    = INFO
UntaggedJetSelection.OutputLevel  = INFO
ElectronSelection.OutputLevel     = INFO
MuonSelection.OutputLevel         = INFO

TriggerDecisionFilter.OutputLevel = INFO
EventSelection.OutputLevel        = INFO

if ExecuteChannelPreSelection or ExecuteChannelSelection:
  ElectronEtaCrackFilter.OutputLevel = INFO
        
if SelectTruth:

  TopVertexFilter.OutputLevel                      = INFO
  TopVertexFilter.McVtxFilterTool.OutputLevel      = INFO
  TopVertexFilter.TruthParticleCnvTool.OutputLevel = INFO
  
  WVertexFilter.OutputLevel                      = INFO
  WVertexFilter.McVtxFilterTool.OutputLevel      = INFO
  WVertexFilter.TruthParticleCnvTool.OutputLevel = INFO
  
  ZVertexFilter.OutputLevel                      = INFO
  ZVertexFilter.McVtxFilterTool.OutputLevel      = INFO
  ZVertexFilter.TruthParticleCnvTool.OutputLevel = INFO
      
if OutputFormat == "D1PD" or OutputFormat == "D2PD":

  if ApplySlimming:
  
    JetSlimming.OutputLevel     = INFO
    TrackSlimming.OutputLevel   = INFO
    TriggerSlimming.OutputLevel = INFO
    
if OutputFormat == "D1PD":

  if ApplyThinning:
  
    ServiceMgr.ThinningSvc.OutputLevel = INFO
    ContainerThinning.OutputLevel      = INFO
  
if OutputFormat == "D3PD":

  TreeMaker.OutputLevel        = INFO
  TriggerTreeMaker.OutputLevel = INFO

  if RecordTruth:
    TruthTreeMaker.OutputLevel = INFO
    
if OutputFormat == "D4PD":
  NtupleMaker.OutputLevel = INFO


# Selection parameters

JetPreSelection.InputContainerName  = JetPreSelection_InputContainerName
JetPreSelection.OutputContainerName = JetPreSelection_OutputContainerName

JetPreSelection.SelectionInfoContainerName = JetPreSelection_SelectionInfoContainerName
JetPreSelection.SelectionLabel             = JetPreSelection_SelectionLabel 
  
JetPreSelection.PtCut  = JetPreSelection_PtCut
JetPreSelection.EtaCut = JetPreSelection_EtaCut
  
ElectronPreSelection.InputContainerName  = ElectronPreSelection_InputContainerName
ElectronPreSelection.OutputContainerName = ElectronPreSelection_OutputContainerName
ElectronPreSelection.JetContainerName    = ElectronPreSelection_JetContainerName

ElectronPreSelection.SelectionInfoContainerName = ElectronPreSelection_SelectionInfoContainerName
ElectronPreSelection.SelectionLabel             = ElectronPreSelection_SelectionLabel
  
ElectronPreSelection.Author           = ElectronPreSelection_Author 
ElectronPreSelection.EmMask           = ElectronPreSelection_EmMask
ElectronPreSelection.PtCut            = ElectronPreSelection_PtCut
ElectronPreSelection.EtaCut           = ElectronPreSelection_EtaCut
ElectronPreSelection.ApplyEtConeCut   = ElectronPreSelection_ApplyEtConeCut
ElectronPreSelection.ConeSize         = ElectronPreSelection_ConeSize
ElectronPreSelection.EtConeCut        = ElectronPreSelection_EtConeCut
ElectronPreSelection.ApplyJetDRCut    = ElectronPreSelection_ApplyJetDRCut
ElectronPreSelection.JetDRCut         = ElectronPreSelection_JetDRCut
ElectronPreSelection.ApplyEtaCrackCut = ElectronPreSelection_ApplyEtaCrackCut
ElectronPreSelection.MinEtaCrack      = ElectronPreSelection_MinEtaCrack
ElectronPreSelection.MaxEtaCrack      = ElectronPreSelection_MaxEtaCrack
  
MuonPreSelection.InputContainerName  = MuonPreSelection_InputContainerName  
MuonPreSelection.OutputContainerName = MuonPreSelection_OutputContainerName
MuonPreSelection.JetContainerName    = MuonPreSelection_JetContainerName

MuonPreSelection.SelectionInfoContainerName = MuonPreSelection_SelectionInfoContainerName
MuonPreSelection.SelectionLabel             = MuonPreSelection_SelectionLabel
  
MuonPreSelection.ApplyIsHighPtCut  = MuonPreSelection_ApplyIsHighPtCut
MuonPreSelection.ApplyBestMatchCut = MuonPreSelection_ApplyBestMatchCut
MuonPreSelection.Author            = MuonPreSelection_Author
MuonPreSelection.PtCut             = MuonPreSelection_PtCut
MuonPreSelection.EtaCut            = MuonPreSelection_EtaCut
MuonPreSelection.ApplyEtConeCut    = MuonPreSelection_ApplyEtConeCut
MuonPreSelection.ConeSize          = MuonPreSelection_ConeSize
MuonPreSelection.EtConeCut         = MuonPreSelection_EtConeCut
MuonPreSelection.ApplyJetDRCut     = MuonPreSelection_ApplyJetDRCut
MuonPreSelection.JetDRCut          = MuonPreSelection_JetDRCut
  
PhotonPreSelection.InputContainerName  = PhotonPreSelection_InputContainerName
PhotonPreSelection.OutputContainerName = PhotonPreSelection_OutputContainerName

PhotonPreSelection.SelectionInfoContainerName = PhotonPreSelection_SelectionInfoContainerName
PhotonPreSelection.SelectionLabel             = PhotonPreSelection_SelectionLabel
  
PhotonPreSelection.Author         = PhotonPreSelection_Author 
PhotonPreSelection.EmMask         = PhotonPreSelection_EmMask
PhotonPreSelection.PtCut          = PhotonPreSelection_PtCut
PhotonPreSelection.EtaCut         = PhotonPreSelection_EtaCut
PhotonPreSelection.ApplyEtConeCut = PhotonPreSelection_ApplyEtConeCut
PhotonPreSelection.ConeSize       = PhotonPreSelection_ConeSize
PhotonPreSelection.EtConeCut      = PhotonPreSelection_EtConeCut
    
TauJetPreSelection.InputContainerName  = TauJetPreSelection_InputContainerName
TauJetPreSelection.OutputContainerName = TauJetPreSelection_OutputContainerName

TauJetPreSelection.SelectionInfoContainerName = TauJetPreSelection_SelectionInfoContainerName
TauJetPreSelection.SelectionLabel             = TauJetPreSelection_SelectionLabel
  
TauJetPreSelection.Author                = TauJetPreSelection_Author
TauJetPreSelection.TauFlag               = TauJetPreSelection_TauFlag
TauJetPreSelection.PtCut                 = TauJetPreSelection_PtCut
TauJetPreSelection.EtaCut                = TauJetPreSelection_EtaCut
TauJetPreSelection.MinTrackNumber        = TauJetPreSelection_MinTrackNumber
TauJetPreSelection.MaxTrackNumber        = TauJetPreSelection_MaxTrackNumber
TauJetPreSelection.HadronicEtFractionCut = TauJetPreSelection_HadronicEtFractionCut
TauJetPreSelection.DiscriminantName      = TauJetPreSelection_DiscriminantName
TauJetPreSelection.DiscriminantType      = TauJetPreSelection_DiscriminantType
TauJetPreSelection.DiscriminantCut       = TauJetPreSelection_DiscriminantCut
  
JetSelection.InputContainerName  = JetSelection_InputContainerName
JetSelection.OutputContainerName = JetSelection_OutputContainerName

JetSelection.SelectionInfoContainerName = JetSelection_SelectionInfoContainerName
JetSelection.SelectionLabel             = JetSelection_SelectionLabel
  
JetSelection.PtCut  = JetSelection_PtCut
JetSelection.EtaCut = JetSelection_EtaCut

TaggedJetSelection.InputContainerName  = TaggedJetSelection_InputContainerName
TaggedJetSelection.OutputContainerName = TaggedJetSelection_OutputContainerName

TaggedJetSelection.SelectionInfoContainerName = TaggedJetSelection_SelectionInfoContainerName
TaggedJetSelection.SelectionLabel             = TaggedJetSelection_SelectionLabel
  
TaggedJetSelection.PtCut            = TaggedJetSelection_PtCut
TaggedJetSelection.EtaCut           = TaggedJetSelection_EtaCut
TaggedJetSelection.TaggingAlgorithm = TaggedJetSelection_TaggingAlgorithm
TaggedJetSelection.TaggingWeightCut = TaggedJetSelection_TaggingWeightCut
  
UntaggedJetSelection.InputContainerName  = UntaggedJetSelection_InputContainerName
UntaggedJetSelection.OutputContainerName = UntaggedJetSelection_OutputContainerName
  
UntaggedJetSelection.PtCut            = UntaggedJetSelection_PtCut
UntaggedJetSelection.EtaCut           = UntaggedJetSelection_EtaCut
UntaggedJetSelection.TaggingAlgorithm = UntaggedJetSelection_TaggingAlgorithm
UntaggedJetSelection.TaggingWeightCut = UntaggedJetSelection_TaggingWeightCut
    
ElectronSelection.InputContainerName  = ElectronSelection_InputContainerName
ElectronSelection.OutputContainerName = ElectronSelection_OutputContainerName
ElectronSelection.JetContainerName    = ElectronSelection_JetContainerName

ElectronSelection.SelectionInfoContainerName = ElectronSelection_SelectionInfoContainerName
ElectronSelection.SelectionLabel             = ElectronSelection_SelectionLabel
    
ElectronSelection.Author           = ElectronSelection_Author 
ElectronSelection.EmMask           = ElectronSelection_EmMask
ElectronSelection.PtCut            = ElectronSelection_PtCut
ElectronSelection.EtaCut           = ElectronSelection_EtaCut
ElectronSelection.ApplyEtConeCut   = ElectronSelection_ApplyEtConeCut
ElectronSelection.ConeSize         = ElectronSelection_ConeSize
ElectronSelection.EtConeCut        = ElectronSelection_EtConeCut
ElectronSelection.ApplyJetDRCut    = ElectronSelection_ApplyJetDRCut
ElectronSelection.JetDRCut         = ElectronSelection_JetDRCut
ElectronSelection.ApplyEtaCrackCut = ElectronSelection_ApplyEtaCrackCut
ElectronSelection.MinEtaCrack      = ElectronSelection_MinEtaCrack
ElectronSelection.MaxEtaCrack      = ElectronSelection_MaxEtaCrack
    
MuonSelection.InputContainerName  = MuonSelection_InputContainerName  
MuonSelection.OutputContainerName = MuonSelection_OutputContainerName
MuonSelection.JetContainerName    = MuonSelection_JetContainerName

MuonSelection.SelectionInfoContainerName = MuonSelection_SelectionInfoContainerName
MuonSelection.SelectionLabel             = MuonSelection_SelectionLabel
  
MuonSelection.ApplyIsHighPtCut  = MuonSelection_ApplyIsHighPtCut
MuonSelection.ApplyBestMatchCut = MuonSelection_ApplyBestMatchCut
MuonSelection.Author            = MuonSelection_Author
MuonSelection.PtCut             = MuonSelection_PtCut
MuonSelection.EtaCut            = MuonSelection_EtaCut
MuonSelection.ApplyEtConeCut    = MuonSelection_ApplyEtConeCut
MuonSelection.ConeSize          = MuonSelection_ConeSize
MuonSelection.EtConeCut         = MuonSelection_EtConeCut
MuonSelection.ApplyJetDRCut     = MuonSelection_ApplyJetDRCut
MuonSelection.JetDRCut          = MuonSelection_JetDRCut
          

# OverlapFilter parameters

OverlapFilter.RootContainerName          = OverlapFilter_RootContainerName
OverlapFilter.InputContainerName         = OverlapFilter_InputContainerName
OverlapFilter.OutputContainerName        = OverlapFilter_OutputContainerName
OverlapFilter.SelectionInfoContainerName = OverlapFilter_SelectionInfoContainerName
OverlapFilter.SelectionLabel             = OverlapFilter_SelectionLabel
OverlapFilter.FilterSameContainerType    = OverlapFilter_FilterSameContainerType
OverlapFilter.DeltaRCut                  = OverlapFilter_DeltaRCut


# TriggerDecisionFilter parameters

TriggerDecisionTool.UseFDRMode                = TriggerDecisionTool_UseFDRMode
TriggerDecisionFilter.AcceptedChainName       = TriggerDecisionFilter_AcceptedChainName
TriggerDecisionFilter.SelectedChainName       = TriggerDecisionFilter_SelectedChainName
TriggerDecisionFilter.TriggerDecisionInfoName = TriggerDecisionFilter_TriggerDecisionInfoName
    
    
# EventFilter parameters
    
EventSelection.MissingEtName       = EventSelection_MissingEtName
EventSelection.ContainerName       = EventSelection_ContainerName
EventSelection.FirstContainerName  = EventSelection_FirstContainerName
EventSelection.SecondContainerName = EventSelection_SecondContainerName
  
EventSelection.MissingEtThreshold = EventSelection_MissingEtThreshold
EventSelection.PtThreshold        = EventSelection_PtThreshold
EventSelection.FirstPtThreshold   = EventSelection_FirstPtThreshold
EventSelection.SecondPtThreshold  = EventSelection_SecondPtThreshold
EventSelection.EtaThreshold       = EventSelection_EtaThreshold
EventSelection.FirstEtaThreshold  = EventSelection_FirstEtaThreshold
EventSelection.SecondEtaThreshold = EventSelection_SecondEtaThreshold
  
EventSelection.MinNumber    = EventSelection_MinNumber
EventSelection.MaxNumber    = EventSelection_MaxNumber
EventSelection.MinSumNumber = EventSelection_MinSumNumber
EventSelection.MaxSumNumber = EventSelection_MaxSumNumber


# ElectronEtaCrackFilter parameters

if ExecuteChannelPreSelection or ExecuteChannelSelection:

  ElectronEtaCrackFilter.ElectronContainerName = ElectronEtaCrackFilter_ElectronContainerName
  ElectronEtaCrackFilter.MinEtaCrack           = ElectronEtaCrackFilter_MinEtaCrack 
  ElectronEtaCrackFilter.MaxEtaCrack           = ElectronEtaCrackFilter_MaxEtaCrack 
  ElectronEtaCrackFilter.MinNumber             = ElectronEtaCrackFilter_MinNumber
  ElectronEtaCrackFilter.MaxNumber             = ElectronEtaCrackFilter_MaxNumber


# VertexFilter parameters

if SelectTruth:

  TopVertexFilter.McVtxFilterTool.DoSignalProcessVtx        = True
  TopVertexFilter.McVtxFilterTool.McEventsOutput            = "GEN_TopVertex"
  TopVertexFilter.TruthParticleCnvTool.McEvents             = "GEN_TopVertex"
  TopVertexFilter.McVtxFilterTool.DecayPatterns             = TopVertexFilter_DecayPatterns 
  TopVertexFilter.McVtxFilterTool.McEvents                  = TopVertexFilter_InputContainerName
  TopVertexFilter.TruthParticleCnvTool.TruthParticlesOutput = TopVertexFilter_OutputContainerName
  
  WVertexFilter.McVtxFilterTool.DoSignalProcessVtx        = True
  WVertexFilter.McVtxFilterTool.McEventsOutput            = "GEN_WVertex"
  WVertexFilter.TruthParticleCnvTool.McEvents             = "GEN_WVertex"
  WVertexFilter.McVtxFilterTool.DecayPatterns             = WVertexFilter_DecayPatterns 
  WVertexFilter.McVtxFilterTool.McEvents                  = WVertexFilter_InputContainerName
  WVertexFilter.TruthParticleCnvTool.TruthParticlesOutput = WVertexFilter_OutputContainerName
  
  ZVertexFilter.McVtxFilterTool.DoSignalProcessVtx        = True
  ZVertexFilter.McVtxFilterTool.McEventsOutput            = "GEN_ZVertex"
  ZVertexFilter.TruthParticleCnvTool.McEvents             = "GEN_ZVertex"
  ZVertexFilter.McVtxFilterTool.DecayPatterns             = ZVertexFilter_DecayPatterns 
  ZVertexFilter.McVtxFilterTool.McEvents                  = ZVertexFilter_InputContainerName
  ZVertexFilter.TruthParticleCnvTool.TruthParticlesOutput = ZVertexFilter_OutputContainerName


# JetSlimming and TrackSlimming parameters

if OutputFormat == "D1PD" or OutputFormat == "D2PD": 

  if ApplySlimming:

    JetSlimming.JetContainerName             = JetSlimming_JetContainerName
    TrackSlimming.TrackParticleContainerName = TrackSlimming_TrackParticleContainerName
    TrackSlimming.TrackPtCut                 = TrackSlimming_TrackPtCut
    
    
# ContainerThinning parameters

if OutputFormat == "D1PD":

  if ApplyThinning:
  
    ContainerThinning.ContainerName              = ContainerThinning_ContainerName
    ContainerThinning.SelectionInfoContainerName = ContainerThinning_SelectionInfoContainerName
    ContainerThinning.RequiredSelectionLabel     = ContainerThinning_RequiredSelectionLabel


# TreeMaker parameters

if OutputFormat == "D3PD":

  TreeMaker.TreeName = TreeName

  TreeMaker.McEventContainerName       = TreeMaker_McEventContainerName
  TreeMaker.EventInfoName              = TreeMaker_EventInfoName
  TreeMaker.MissingEtName              = TreeMaker_MissingEtName
  TreeMaker.MissingEtLabel             = TreeMaker_MissingEtLabel
  TreeMaker.TrackParticleContainerName = TreeMaker_TrackParticleContainerName
  TreeMaker.ContainerName              = TreeMaker_ContainerName
  TreeMaker.ContainerLabel             = TreeMaker_ContainerLabel
  TreeMaker.PtCut                      = TreeMaker_PtCut 

  TreeMaker.TrackMuonDRCutMin = TreeMaker_TrackMuonDRCutMin
  TreeMaker.TrackMuonDRCutMax = TreeMaker_TrackMuonDRCutMax
  TreeMaker.TrackMuonPtCut    = TreeMaker_TrackMuonPtCut
  

# TriggerTreeMaker parameters

if OutputFormat == "D3PD":

  TriggerTreeMaker.TreeName = TriggerTreeName
  
  TriggerTreeMaker.TriggerDecisionInfoName  = TriggerTreeMaker_TriggerDecisionInfoName 
  TriggerTreeMaker.TriggerDecisionInfoLabel = TriggerTreeMaker_TriggerDecisionInfoLabel


# TruthTreeMaker parameters

if OutputFormat == "D3PD":
  
  if RecordTruth:

    TruthTreeMaker.TreeName = TruthTreeName

    TruthTreeMaker.McEventContainerName = TruthTreeMaker_McEventContainerName
    TruthTreeMaker.MissingEtName        = TruthTreeMaker_MissingEtName
    TruthTreeMaker.MissingEtLabel       = TruthTreeMaker_MissingEtLabel
    TruthTreeMaker.MissingEtSource      = TruthTreeMaker_MissingEtSource
    TruthTreeMaker.ContainerName        = TruthTreeMaker_ContainerName
    TruthTreeMaker.ContainerLabel       = TruthTreeMaker_ContainerLabel


# NtupleMaker parameters

if OutputFormat == "D4PD":
  
  NtupleMaker.FileName   = OutputFileName
  NtupleMaker.NtupleName = NtupleName

  NtupleMaker.EventInfoName            = NtupleMaker_EventInfoName
  NtupleMaker.MissingEtName            = NtupleMaker_MissingEtName
  NtupleMaker.ElectronContainerName    = NtupleMaker_ElectronContainerName
  NtupleMaker.MuonContainerName        = NtupleMaker_MuonContainerName
  NtupleMaker.TaggedJetContainerName   = NtupleMaker_TaggedJetContainerName
  NtupleMaker.UntaggedJetContainerName = NtupleMaker_UntaggedJetContainerName
   
