# Input and Output parameters

#InputCollections = ['/sps/atlas/l/lucotte/91.FDR2/AOD.024293._00025.pool.root.1']
#InputCollections = ['/sps/atlas/l/lleres/DQ2/MC8.108340.st_tchan_enu_McAtNlo_Jimmy.AOD.00001.pool.root']
#InputCollections = ['/sps/atlas/c/clement/AODs/Wjets/w0j/AlpgenJimmy_w0j_0.FastAOD.14.2.21.pool.root']
InputCollections = ["/data1/atlas/topgroup/AOD_10TEV/mc08.105502.AcerMC_tchan.recon.AOD.e352_s462_r541/AOD.026011._00001.pool.root.1"]
OutputFileName = "mc08.105502.AcerMC_tchan.SingleTopD3PD.root"

NbEventSkip = 0
NbEventMax  = 2000

FullReco = True

if FullReco:

  EventInfoName              = "ByteStreamEventInfo"
  MissingEtName              = "MET_RefFinal"
  PhotonContainerName        = "PhotonAODCollection"
  ElectronContainerName      = "ElectronAODCollection"
  MuonContainerName          = "StacoMuonCollection"
  TauJetContainerName        = "TauRecContainer"
  JetContainerName           = "Cone4H1TowerJets"
  TrackParticleContainerName = "TrackParticleCandidate"
  
else:

  EventInfoName              = "McEventInfo"
  MissingEtName              = "AtlfastMissingEt"
  PhotonContainerName        = "AtlfastPhotonCollection"
  ElectronContainerName      = "AtlfastElectronCollection"
  MuonContainerName          = "AtlfastMuonCollection"
  TauJetContainerName        = "AtlfastTauJet1p3pContainer"
  JetContainerName           = "AtlfastJetContainer"
  TrackParticleContainerName = "AtlfastTrackParticles"

TreeName = "CollectionTree"


# Sequence parameters

ExecuteSelection       = True
ExecuteOverlapRemoval  = True

ExecutePhotonSelection = True
ExecuteTauJetSelection = True

FillPhotonBranches     = True
FillTauJetBranches     = True

if not ExecuteSelection: 
  ExecuteOverlapRemoval = False


# Object Selection parameters

JetSelection_MinPtCut = 15.0*GeV
JetSelection_MaxPtCut = 500.0*GeV
JetSelection_EtaCut   = 5.0

TaggedJetSelection_MinPtCut         = 15.0*GeV
TaggedJetSelection_MaxPtCut         = 500.0*GeV
TaggedJetSelection_EtaCut           = 2.5
TaggedJetSelection_TaggingAlgorithm = "IP2D"
TaggedJetSelection_TaggingWeightCut = 7.05

UntaggedJetSelection_MinPtCut         = 15.0*GeV
UntaggedJetSelection_MaxPtCut         = 500.0*GeV
UntaggedJetSelection_EtaCut           = 5.0
UntaggedJetSelection_TaggingAlgorithm = "IP2D"
UntaggedJetSelection_TaggingWeightCut = 7.05

if FullReco:
  ElectronSelection_EmMask = "Medium"
  ElectronSelection_Author = "Electron"
else:
  ElectronSelection_EmMask = "None"
  ElectronSelection_Author = "Either"
  
ElectronSelection_MinPtCut       = 30.0*GeV
ElectronSelection_MaxPtCut       = 500.0*GeV
ElectronSelection_EtaCut         = 2.5
ElectronSelection_ApplyEtConeCut = False
ElectronSelection_ConeSize       = 0.2 
ElectronSelection_EtConeCut      = 6.0*GeV
ElectronSelection_ApplyJetDRCut  = False
ElectronSelection_JetDRCut       = 0.4
  
MuonSelection_Author         = "All" 
MuonSelection_MinPtCut       = 30.0*GeV
MuonSelection_MaxPtCut       = 500.0*GeV
MuonSelection_EtaCut         = 2.5
MuonSelection_ApplyEtConeCut = False
MuonSelection_ConeSize       = 0.2
MuonSelection_EtConeCut      = 6.0*GeV
MuonSelection_ApplyJetDRCut  = False
MuonSelection_JetDRCut       = 0.4

if FullReco:
  PhotonSelection_Author = "Photon"
else:
  PhotonSelection_Author = "Either"

PhotonSelection_EmMask         = "None"
PhotonSelection_MinPtCut       = 30.0*GeV
PhotonSelection_MaxPtCut       = 500.0*GeV
PhotonSelection_EtaCut         = 2.4
PhotonSelection_ApplyEtConeCut = False
PhotonSelection_ConeSize       = 0.2
PhotonSelection_EtConeCut      = 6.0*GeV
 
TauJetSelection_MinPtCut = 30.0*GeV
TauJetSelection_MaxPtCut = 500.0*GeV
TauJetSelection_EtaCut   = 2.5

JetSelection_InputContainerName         = JetContainerName
TaggedJetSelection_InputContainerName   = JetContainerName
UntaggedJetSelection_InputContainerName = JetContainerName
ElectronSelection_InputContainerName    = ElectronContainerName
ElectronSelection_JetContainerName      = JetContainerName
MuonSelection_InputContainerName        = MuonContainerName
MuonSelection_JetContainerName          = JetContainerName
PhotonSelection_InputContainerName      = PhotonContainerName
TauJetSelection_InputContainerName      = TauJetContainerName

JetSelection_OutputContainerName         = "SelectedJets"
TaggedJetSelection_OutputContainerName   = "SelectedTaggedJets"
UntaggedJetSelection_OutputContainerName = "SelectedUntaggedJets"
ElectronSelection_OutputContainerName    = "SelectedElectrons"
MuonSelection_OutputContainerName        = "SelectedMuons"
PhotonSelection_OutputContainerName      = "SelectedPhotons"
TauJetSelection_OutputContainerName      = "SelectedTauJets"


# Overlap Removal parameters
# The input container names should contain "Photon", "Electron", "Muon", "Tau" or "Jet" to be recognized by the algorithm

OverlapFilter_OutputPhotonContainerName      = "OverlapSelectedPhotons"
OverlapFilter_OutputMuonContainerName        = "OverlapSelectedMuons"
OverlapFilter_OutputTauJetContainerName      = "OverlapSelectedTauJets"
OverlapFilter_OutputJetContainerName         = "OverlapSelectedJets"
OverlapFilter_OutputTaggedJetContainerName   = "OverlapSelectedTaggedJets"
OverlapFilter_OutputUntaggedJetContainerName = "OverlapSelectedUntaggedJets"

OverlapFilter_PhotonFilterSameContainerType      = False
OverlapFilter_ElectronFilterSameContainerType    = False
OverlapFilter_MuonFilterSameContainerType        = False
OverlapFilter_TauJetFilterSameContainerType      = False
OverlapFilter_JetFilterSameContainerType         = False
OverlapFilter_TaggedJetFilterSameContainerType   = False
OverlapFilter_UntaggedJetFilterSameContainerType = False

OverlapFilter_PhotonDeltaRCut      = 0.1
OverlapFilter_ElectronDeltaRCut    = 0.1
OverlapFilter_MuonDeltaRCut        = 0.1
OverlapFilter_TauJetDeltaRCut      = 0.1
OverlapFilter_JetDeltaRCut         = 0.1
OverlapFilter_TaggedJetDeltaRCut   = 0.1
OverlapFilter_UntaggedJetDeltaRCut = 0.1
			 
OverlapFilter_RootContainerName = ElectronSelection_OutputContainerName

OverlapFilter_InputContainerName      = []
OverlapFilter_OutputContainerName     = []
OverlapFilter_FilterSameContainerType = []
OverlapFilter_DeltaRCut               = []

if ExecutePhotonSelection:

  OverlapFilter_InputContainerName      += [PhotonSelection_OutputContainerName]
  OverlapFilter_OutputContainerName     += [OverlapFilter_OutputPhotonContainerName]
  OverlapFilter_FilterSameContainerType += [OverlapFilter_PhotonFilterSameContainerType]
  OverlapFilter_DeltaRCut               += [OverlapFilter_PhotonDeltaRCut]

OverlapFilter_InputContainerName      += [MuonSelection_OutputContainerName]
OverlapFilter_OutputContainerName     += [OverlapFilter_OutputMuonContainerName]
OverlapFilter_FilterSameContainerType += [OverlapFilter_MuonFilterSameContainerType]
OverlapFilter_DeltaRCut               += [OverlapFilter_MuonDeltaRCut]

if ExecuteTauJetSelection:

  OverlapFilter_InputContainerName      += [TauJetSelection_OutputContainerName]
  OverlapFilter_OutputContainerName     += [OverlapFilter_OutputTauJetContainerName]
  OverlapFilter_FilterSameContainerType += [OverlapFilter_TauJetFilterSameContainerType]
  OverlapFilter_DeltaRCut               += [OverlapFilter_TauJetDeltaRCut]

OverlapFilter_InputContainerName      += [JetSelection_OutputContainerName]
OverlapFilter_OutputContainerName     += [OverlapFilter_OutputJetContainerName]
OverlapFilter_FilterSameContainerType += [OverlapFilter_JetFilterSameContainerType]
OverlapFilter_DeltaRCut               += [OverlapFilter_JetDeltaRCut]

OverlapFilter_InputContainerName      += [TaggedJetSelection_OutputContainerName]
OverlapFilter_OutputContainerName     += [OverlapFilter_OutputTaggedJetContainerName]
OverlapFilter_FilterSameContainerType += [OverlapFilter_TaggedJetFilterSameContainerType]
OverlapFilter_DeltaRCut               += [OverlapFilter_TaggedJetDeltaRCut]

OverlapFilter_InputContainerName      += [UntaggedJetSelection_OutputContainerName]
OverlapFilter_OutputContainerName     += [OverlapFilter_OutputUntaggedJetContainerName]
OverlapFilter_FilterSameContainerType += [OverlapFilter_UntaggedJetFilterSameContainerType]
OverlapFilter_DeltaRCut               += [OverlapFilter_UntaggedJetDeltaRCut]


# Event Filter parameters
# The input container names should contain "Photon", "Electron", "Muon", "Tau" or "Jet" to be recognized by the algorithm

EventFilter_MissingEtCut  = 0.0*GeV
EventFilter_MissingEtName = "None"

EventFilter_MinNumber = []
EventFilter_MaxNumber = []

EventFilter_ContainerName = []

EventFilter_MinSumNumber = [1]
EventFilter_MaxSumNumber = [100]

EventFilter_FirstContainerName  = []
EventFilter_SecondContainerName = []

EventFilter_FirstContainerName  += [ElectronSelection_OutputContainerName]

if ExecuteOverlapRemoval:
  EventFilter_SecondContainerName += [OverlapFilter_OutputMuonContainerName]
else:
  EventFilter_SecondContainerName += [MuonSelection_OutputContainerName]


# Tree Maker parameters
# The input container names should contain "Photon", "Electron", "Muon", "Tau" or "Jet" to be recognized by the algorithm

TreeMaker_TrackMuonDRCutMin = 0.01
TreeMaker_TrackMuonDRCutMax = 0.45
TreeMaker_TrackMuonPtCut    = 1.0*GeV

TreeMaker_EventInfoName              = EventInfoName
TreeMaker_MissingEtName              = MissingEtName
TreeMaker_TrackParticleContainerName = TrackParticleContainerName

TreeMaker_ContainerName  = []
TreeMaker_ContainerLabel = []

if ExecuteSelection:

  TreeMaker_ContainerName  += [ElectronSelection_OutputContainerName]
  TreeMaker_ContainerLabel += ["El"]

  if ExecuteOverlapRemoval:
  
    if ExecutePhotonSelection and FillPhotonBranches:
      TreeMaker_ContainerName  += [OverlapFilter_OutputPhotonContainerName]
      TreeMaker_ContainerLabel += ["Ph"]
      
    TreeMaker_ContainerName  += [OverlapFilter_OutputMuonContainerName]
    TreeMaker_ContainerLabel += ["Mu"]
    
    if ExecuteTauJetSelection and FillTauJetBranches:
      TreeMaker_ContainerName  += [OverlapFilter_OutputTauJetContainerName]
      TreeMaker_ContainerLabel += ["Tau"]
      
    TreeMaker_ContainerName  += [OverlapFilter_OutputJetContainerName]
    TreeMaker_ContainerLabel += ["PJet"]
    TreeMaker_ContainerName  += [OverlapFilter_OutputTaggedJetContainerName]
    TreeMaker_ContainerLabel += ["BJet"]
    TreeMaker_ContainerName  += [OverlapFilter_OutputUntaggedJetContainerName]
    TreeMaker_ContainerLabel += ["UJet"]
      
  else:
  
    if ExecutePhotonSelection and FillPhotonBranches:
      TreeMaker_ContainerName  += [PhotonSelection_OutputContainerName]
      TreeMaker_ContainerLabel += ["Ph"]
      
    TreeMaker_ContainerName  += [MuonSelection_OutputContainerName]
    TreeMaker_ContainerLabel += ["Mu"]
    
    if ExecuteTauJetSelection and FillTauJetBranches:
      TreeMaker_ContainerName  += [TauJetSelection_OutputContainerName]
      TreeMaker_ContainerLabel += ["Tau"]
      
    TreeMaker_ContainerName  += [JetSelection_OutputContainerName]
    TreeMaker_ContainerLabel += ["PJet"]
    TreeMaker_ContainerName  += [TaggedJetSelection_OutputContainerName]
    TreeMaker_ContainerLabel += ["BJet"]
    TreeMaker_ContainerName  += [UntaggedJetSelection_OutputContainerName]
    TreeMaker_ContainerLabel += ["UJet"]

else:

  if FillPhotonBranches:
    TreeMaker_ContainerName  += [PhotonContainerName]
    TreeMaker_ContainerLabel += ["Ph"]
      
  TreeMaker_ContainerName  += [ElectronContainerName]
  TreeMaker_ContainerLabel += ["El"]
  TreeMaker_ContainerName  += [MuonContainerName]
  TreeMaker_ContainerLabel += ["Mu"]
 
  if FillTauJetBranches:
    TreeMaker_ContainerName  += [TauJetContainerName]
    TreeMaker_ContainerLabel += ["Tau"]
      
  TreeMaker_ContainerName  += [JetContainerName]
  TreeMaker_ContainerLabel += ["PJet"]
  
			
include("SingleTopD3PDMaker.py")
