# Input and Output parameters

#InputCollections = ['/sps/atlas/l/lucotte/91.FDR2/AOD.024293._00025.pool.root.1']
InputCollections = ['/sps/atlas/l/lleres/DQ2/MC8.108340.st_tchan_enu_McAtNlo_Jimmy.AOD.00001.pool.root']
#InputCollections = ['/sps/atlas/c/clement/AODs/Wjets/w0j/AlpgenJimmy_w0j_0.FastAOD.14.2.21.pool.root']

OutputFileName = "SingleTopD4PD.root"

NbEventSkip = 0
NbEventMax  = 2000

ChannelName = "STt"

FullReco = False

if FullReco:

  EventInfoName              = "ByteStreamEventInfo"
  MissingEtName              = "MET_RefFinal"
  PhotonContainerName        = "PhotonAODCollection"
  ElectronContainerName      = "ElectronAODCollection"
  MuonContainerName          = "StacoMuonCollection"
  TauJetContainerName        = "TauRecContainer"
  JetContainerName           = "Cone4H1TowerJets"
  TrackParticleContainerName = "TrackParticleCandidate"
  
else:

  EventInfoName              = "McEventInfo"
  MissingEtName              = "AtlfastMissingEt"
  PhotonContainerName        = "AtlfastPhotonCollection"
  ElectronContainerName      = "AtlfastElectronCollection"
  MuonContainerName          = "AtlfastMuonCollection"
  TauJetContainerName        = "AtlfastTauJet1p3pContainer"
  JetContainerName           = "AtlfastJetContainer"
  TrackParticleContainerName = "AtlfastTrackParticles"

TreeName = "CollectionTree"


# Object Selection parameters

StdPtJetSelection_MinPtCut = 30.0*GeV
LowPtJetSelection_MinPtCut = 15.0*GeV

JetSelection_MaxPtCut = 500.0*GeV
JetSelection_EtaCut   = 5.0

StdPtJetSelection_MaxPtCut = JetSelection_MaxPtCut
StdPtJetSelection_EtaCut   = JetSelection_EtaCut 

LowPtJetSelection_MaxPtCut = JetSelection_MaxPtCut
LowPtJetSelection_EtaCut   = JetSelection_EtaCut

StdPtTaggedJetSelection_MinPtCut  = 30.0*GeV
HighPtTaggedJetSelection_MinPtCut = 50.0*GeV
LowPtTaggedJetSelection_MinPtCut  = 15.0*GeV

TaggedJetSelection_MaxPtCut         = 500.0*GeV
TaggedJetSelection_EtaCut           = 2.5
TaggedJetSelection_TaggingAlgorithm = "IP2D"
TaggedJetSelection_TaggingWeightCut = 7.05

StdPtTaggedJetSelection_MaxPtCut         = TaggedJetSelection_MaxPtCut
StdPtTaggedJetSelection_EtaCut           = TaggedJetSelection_EtaCut
StdPtTaggedJetSelection_TaggingAlgorithm = TaggedJetSelection_TaggingAlgorithm 
StdPtTaggedJetSelection_TaggingWeightCut = TaggedJetSelection_TaggingWeightCut

HighPtTaggedJetSelection_MaxPtCut         = TaggedJetSelection_MaxPtCut
HighPtTaggedJetSelection_EtaCut           = TaggedJetSelection_EtaCut
HighPtTaggedJetSelection_TaggingAlgorithm = TaggedJetSelection_TaggingAlgorithm 
HighPtTaggedJetSelection_TaggingWeightCut = TaggedJetSelection_TaggingWeightCut

LowPtTaggedJetSelection_MaxPtCut         = TaggedJetSelection_MaxPtCut
LowPtTaggedJetSelection_EtaCut           = TaggedJetSelection_EtaCut
LowPtTaggedJetSelection_TaggingAlgorithm = TaggedJetSelection_TaggingAlgorithm 
LowPtTaggedJetSelection_TaggingWeightCut = TaggedJetSelection_TaggingWeightCut

StdPtUntaggedJetSelection_MinPtCut = 30.0*GeV
LowPtUntaggedJetSelection_MinPtCut = 15.0*GeV

UntaggedJetSelection_MaxPtCut         = 500.0*GeV
UntaggedJetSelection_EtaCut           = 5.0
UntaggedJetSelection_TaggingAlgorithm = "IP2D"
UntaggedJetSelection_TaggingWeightCut = 7.05

StdPtUntaggedJetSelection_MaxPtCut         = UntaggedJetSelection_MaxPtCut
StdPtUntaggedJetSelection_EtaCut           = UntaggedJetSelection_EtaCut
StdPtUntaggedJetSelection_TaggingAlgorithm = UntaggedJetSelection_TaggingAlgorithm 
StdPtUntaggedJetSelection_TaggingWeightCut = UntaggedJetSelection_TaggingWeightCut

LowPtUntaggedJetSelection_MaxPtCut         = UntaggedJetSelection_MaxPtCut
LowPtUntaggedJetSelection_EtaCut           = UntaggedJetSelection_EtaCut
LowPtUntaggedJetSelection_TaggingAlgorithm = UntaggedJetSelection_TaggingAlgorithm 
LowPtUntaggedJetSelection_TaggingWeightCut = UntaggedJetSelection_TaggingWeightCut

StdPtElectronSelection_MinPtCut = 30.0*GeV
LowPtElectronSelection_MinPtCut = 10.0*GeV

if FullReco:
  ElectronSelection_EmMask = "Medium"
  ElectronSelection_Author = "Electron"
else:
  ElectronSelection_EmMask = "None"
  ElectronSelection_Author = "Either"
  
ElectronSelection_MaxPtCut       = 500.0*GeV
ElectronSelection_EtaCut         = 2.5
ElectronSelection_ApplyEtConeCut = False
ElectronSelection_ConeSize       = 0.2 
ElectronSelection_EtConeCut      = 6.0*GeV
ElectronSelection_ApplyJetDRCut  = False
ElectronSelection_JetDRCut       = 0.4
  
StdPtElectronSelection_EmMask         = ElectronSelection_EmMask
StdPtElectronSelection_Author         = ElectronSelection_Author
StdPtElectronSelection_MaxPtCut       = ElectronSelection_MaxPtCut
StdPtElectronSelection_EtaCut         = ElectronSelection_EtaCut
StdPtElectronSelection_ApplyEtConeCut = ElectronSelection_ApplyEtConeCut
StdPtElectronSelection_ConeSize       = ElectronSelection_ConeSize 
StdPtElectronSelection_EtConeCut      = ElectronSelection_EtConeCut
StdPtElectronSelection_ApplyJetDRCut  = ElectronSelection_ApplyJetDRCut
StdPtElectronSelection_JetDRCut       = ElectronSelection_JetDRCut
  
LowPtElectronSelection_EmMask         = ElectronSelection_EmMask
LowPtElectronSelection_Author         = ElectronSelection_Author
LowPtElectronSelection_MaxPtCut       = ElectronSelection_MaxPtCut
LowPtElectronSelection_EtaCut         = ElectronSelection_EtaCut
LowPtElectronSelection_ApplyEtConeCut = ElectronSelection_ApplyEtConeCut
LowPtElectronSelection_ConeSize       = ElectronSelection_ConeSize 
LowPtElectronSelection_EtConeCut      = ElectronSelection_EtConeCut
LowPtElectronSelection_ApplyJetDRCut  = ElectronSelection_ApplyJetDRCut
LowPtElectronSelection_JetDRCut       = ElectronSelection_JetDRCut

StdPtMuonSelection_MinPtCut = 30.0*GeV
LowPtMuonSelection_MinPtCut = 10.0*GeV

MuonSelection_Author         = "All"   
MuonSelection_MaxPtCut       = 500.0*GeV
MuonSelection_EtaCut         = 2.5
MuonSelection_ApplyEtConeCut = False
MuonSelection_ConeSize       = 0.2
MuonSelection_EtConeCut      = 6.0*GeV
MuonSelection_ApplyJetDRCut  = False
MuonSelection_JetDRCut       = 0.4

StdPtMuonSelection_Author         = MuonSelection_Author    
StdPtMuonSelection_MaxPtCut       = MuonSelection_MaxPtCut
StdPtMuonSelection_EtaCut         = MuonSelection_EtaCut
StdPtMuonSelection_ApplyEtConeCut = MuonSelection_ApplyEtConeCut
StdPtMuonSelection_ConeSize       = MuonSelection_ConeSize
StdPtMuonSelection_EtConeCut      = MuonSelection_EtConeCut
StdPtMuonSelection_ApplyJetDRCut  = MuonSelection_ApplyJetDRCut
StdPtMuonSelection_JetDRCut       = MuonSelection_JetDRCut

LowPtMuonSelection_Author         = MuonSelection_Author    
LowPtMuonSelection_MaxPtCut       = MuonSelection_MaxPtCut
LowPtMuonSelection_EtaCut         = MuonSelection_EtaCut
LowPtMuonSelection_ApplyEtConeCut = MuonSelection_ApplyEtConeCut
LowPtMuonSelection_ConeSize       = MuonSelection_ConeSize
LowPtMuonSelection_EtConeCut      = MuonSelection_EtConeCut
LowPtMuonSelection_ApplyJetDRCut  = MuonSelection_ApplyJetDRCut
LowPtMuonSelection_JetDRCut       = MuonSelection_JetDRCut

StdPtJetSelection_InputContainerName = JetContainerName
LowPtJetSelection_InputContainerName = JetContainerName

StdPtTaggedJetSelection_InputContainerName  = JetContainerName
HighPtTaggedJetSelection_InputContainerName = JetContainerName
LowPtTaggedJetSelection_InputContainerName  = JetContainerName

StdPtUntaggedJetSelection_InputContainerName = JetContainerName
LowPtUntaggedJetSelection_InputContainerName = JetContainerName

StdPtElectronSelection_InputContainerName = ElectronContainerName
StdPtElectronSelection_JetContainerName   = JetContainerName
LowPtElectronSelection_InputContainerName = ElectronContainerName
LowPtElectronSelection_JetContainerName   = JetContainerName

StdPtMuonSelection_InputContainerName = MuonContainerName
StdPtMuonSelection_JetContainerName   = JetContainerName
LowPtMuonSelection_InputContainerName = MuonContainerName
LowPtMuonSelection_JetContainerName   = JetContainerName

StdPtJetSelection_OutputContainerName = "StdPtSelectedJets"
LowPtJetSelection_OutputContainerName = "LowPtSelectedJets"

StdPtTaggedJetSelection_OutputContainerName   = "StdPtSelectedTaggedJets"
HighPtTaggedJetSelection_OutputContainerName  = "HighPtSelectedTaggedJets"
LowPtTaggedJetSelection_OutputContainerName   = "LowPtSelectedTaggedJets"

StdPtUntaggedJetSelection_OutputContainerName = "StdPtSelectedUntaggedJets"
LowPtUntaggedJetSelection_OutputContainerName = "LowPtSelectedUntaggedJets"

StdPtElectronSelection_OutputContainerName = "StdPtSelectedElectrons"
LowPtElectronSelection_OutputContainerName = "LowPtSelectedElectrons"

StdPtMuonSelection_OutputContainerName = "StdPtSelectedMuons"
LowPtMuonSelection_OutputContainerName = "LowPtSelectedMuons"


# Overlap Removal parameters
# No computed OverlapFilter


# Event Filter parameters
# The input container names should contain "Photon", "Electron", "Muon", "Tau" or "Jet" to be recognized by the algorithm

# Single Top pre-selection (one W leptonic) : 
# one neutrino missing Et (et>20GeV), one standard pt lepton (pt>30GeV) and no low pt lepton (pt=10-30GeV)
# at least two standard pt jets (pt>30GeV) and at most four low pt jets (pt>15GeV)

PreSelection_MissingEtCut  = 20.0*GeV
PreSelection_MissingEtName = MissingEtName

PreSelection_MinNumber = [2,   0]
PreSelection_MaxNumber = [100, 4]

PreSelection_ContainerName = []

PreSelection_ContainerName += [StdPtJetSelection_OutputContainerName]
PreSelection_ContainerName += [LowPtJetSelection_OutputContainerName]

PreSelection_MinSumNumber = [1, 0]
PreSelection_MaxSumNumber = [1, 1]

PreSelection_FirstContainerName  = []
PreSelection_SecondContainerName = []

PreSelection_FirstContainerName  += [StdPtElectronSelection_OutputContainerName]
PreSelection_FirstContainerName  += [LowPtElectronSelection_OutputContainerName]
PreSelection_SecondContainerName += [StdPtMuonSelection_OutputContainerName]
PreSelection_SecondContainerName += [LowPtMuonSelection_OutputContainerName]

ChannelSelection_MissingEtCut  = 0.0*GeV
ChannelSelection_MissingEtName = "None"

ChannelSelection_MinSumNumber = []
ChannelSelection_MaxSumNumber = []

ChannelSelection_FirstContainerName  = []
ChannelSelection_SecondContainerName = []

if ChannelName == "STt":

# Single Top t-channel selection (t q or t_bar q -> W+ b q or W- b_bar q -> l nu b q ) :
# at least one standard pt tagged jet (pt>30GeV) and at least one high pt tagged jet (pt>50GeV)

  ChannelSelection_MinNumber = [1,   1]
  ChannelSelection_MaxNumber = [100, 100]

  ChannelSelection_ContainerName = []

  ChannelSelection_ContainerName += [StdPtTaggedJetSelection_OutputContainerName]
  ChannelSelection_ContainerName += [HighPtTaggedJetSelection_OutputContainerName]

elif ChannelName == "STWt":

# Single Top W+t selection (W- t or W+ t_bar -> W+ W- b or W+ W- b_bar -> l nu q q b - W leptonic + W hadronic) :
# at least one high pt tagged jet (pt>50GeV), at least one and at most three standard pt untagged jets (pt>30GeV)

  ChannelSelection_MinNumber = [1,   1]
  ChannelSelection_MaxNumber = [100, 3]

  ChannelSelection_ContainerName = []

  ChannelSelection_ContainerName += [HighPtTaggedJetSelection_OutputContainerName]
  ChannelSelection_ContainerName += [StdPtUntaggedJetSelection_OutputContainerName]

elif ChannelName == "STs":

# Single Top s-channel selection (t b_bar or t_bar b -> W+ b b_bar or W- b b_bar -> l nu b b) :
# exactly two standard pt tagged jets (pt>30GeV) and no untagged jet (pt>15GeV)

  ChannelSelection_MinNumber = [2, 0]
  ChannelSelection_MaxNumber = [2, 0]

  ChannelSelection_ContainerName = []

  ChannelSelection_ContainerName += [StdPtTaggedJetSelection_OutputContainerName]
  ChannelSelection_ContainerName += [LowPtUntaggedJetSelection_OutputContainerName]
  
else:

  ChannelSelection_MinNumber = []
  ChannelSelection_MaxNumber = []

  ChannelSelection_ContainerName = []
  
  print("Unknown Channel Name")
  
  
# Tree Maker parameters
# The input container names should contain "Photon", "Electron", "Muon", "Tau" or "Jet" to be recognized by the algorithm

TreeMaker_TrackMuonDRCutMin = 0.01
TreeMaker_TrackMuonDRCutMax = 0.45
TreeMaker_TrackMuonPtCut    = 1.0*GeV

TreeMaker_EventInfoName              = EventInfoName
TreeMaker_MissingEtName              = MissingEtName
TreeMaker_TrackParticleContainerName = TrackParticleContainerName

TreeMaker_ContainerName  = []
TreeMaker_ContainerLabel = []

TreeMaker_ContainerName  += [StdPtElectronSelection_OutputContainerName]
TreeMaker_ContainerLabel += ["El"]

TreeMaker_ContainerName  += [StdPtMuonSelection_OutputContainerName]
TreeMaker_ContainerLabel += ["Mu"]
          
TreeMaker_ContainerName  += [StdPtJetSelection_OutputContainerName]
TreeMaker_ContainerLabel += ["PJet"]

TreeMaker_ContainerName  += [StdPtTaggedJetSelection_OutputContainerName]
TreeMaker_ContainerLabel += ["BJet"]

TreeMaker_ContainerName  += [LowPtUntaggedJetSelection_OutputContainerName]
TreeMaker_ContainerLabel += ["UJet"]

			
include("SingleTopD4PDMaker.py")
