#include "SingleTopDPDMaker/TreeMaker.h"

void TreeMaker::SetMissingEt()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=MissingEtLabel.begin(); Itr!=MissingEtLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;
    
    std::string mEtx;
    std::string mEty;
    std::string mEt;
    std::string mEtSum;
    
    if(Label == "None")
    {
      mEtx   = "MissingEtx";
      mEty   = "MissingEty";
      mEt    = "MissingEt";
      mEtSum = "MissingEtSum"; 
    }
    
    else
    {
      mEtx   = Label+"_"+"MissingEtx";
      mEty   = Label+"_"+"MissingEty";
      mEt    = Label+"_"+"MissingEt";
      mEtSum = Label+"_"+"MissingEtSum";
    }
    
    std::string mEtxD   = mEtx+"/D";
    std::string mEtyD   = mEty+"/D";
    std::string mEtD    = mEt+"/D";
    std::string mEtSumD = mEtSum+"/D";

    aTree->Branch(mEtx.c_str(),   &MissingEtx[Label],   mEtxD.c_str()  );
    aTree->Branch(mEty.c_str(),   &MissingEty[Label],   mEtyD.c_str()  ); 
    aTree->Branch(mEt.c_str(),    &MissingEt[Label],    mEtD.c_str()   );
    aTree->Branch(mEtSum.c_str(), &MissingEtSum[Label], mEtSumD.c_str());
    
  }
    
}

void TreeMaker::ClearMissingEt()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=MissingEtLabel.begin(); Itr!=MissingEtLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;

    MissingEtx[Label]   = -1;
    MissingEty[Label]   = -1;
    MissingEt[Label]    = -1;
    MissingEtSum[Label] = -1;
    
  }
    
}

void TreeMaker::FillMissingEt()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=MissingEtLabel.begin(); Itr!=MissingEtLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;

    MissingEtx[Label]   = aMissingEt[Label]->etx  ()/GeV;
    MissingEty[Label]   = aMissingEt[Label]->ety  ()/GeV;
    MissingEt[Label]    = aMissingEt[Label]->et   ()/GeV;
    MissingEtSum[Label] = aMissingEt[Label]->sumet()/GeV;
    
  }
  
}
