#include "SingleTopDPDMaker/TreeMaker.h"

void TreeMaker::SetMuons()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=MuonContainerLabel.begin(); Itr!=MuonContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;

    Muon_pdgId[Label]  = new std::vector<double>;
    Muon_m[Label]      = new std::vector<double>;
    Muon_charge[Label] = new std::vector<double>;
    Muon_E[Label]      = new std::vector<double>;
    Muon_p_T[Label]    = new std::vector<double>;
    Muon_phi[Label]    = new std::vector<double>;
    Muon_eta[Label]    = new std::vector<double>;
    Muon_px[Label]     = new std::vector<double>;
    Muon_py[Label]     = new std::vector<double>;
    Muon_pz[Label]     = new std::vector<double>;
  
    Muon_author[Label]                           = new std::vector<int>;
    Muon_hasCluster[Label]                       = new std::vector<int>;
    Muon_hasCombinedMuon[Label]                  = new std::vector<int>;
    Muon_bestMatch[Label]                        = new std::vector<int>;
    Muon_isCombinedMuon[Label]                   = new std::vector<int>;
    Muon_hasInDetTrackParticle[Label]            = new std::vector<int>;
    Muon_hasMuonExtrapolatedTrackParticle[Label] = new std::vector<int>;
    Muon_hasCombinedMuonTrackParticle[Label]     = new std::vector<int>;
  
    Muon_matchChi2[Label]        = new std::vector<double>;
    Muon_matchChi2OverDoF[Label] = new std::vector<double>;
    Muon_fitChi2[Label]          = new std::vector<double>;
    Muon_fitChi2OverDoF[Label]   = new std::vector<double>;
  
    Muon_etcone10[Label] = new std::vector<double>;
    Muon_etcone20[Label] = new std::vector<double>;
    Muon_etcone30[Label] = new std::vector<double>;
    Muon_etcone40[Label] = new std::vector<double>;
    Muon_nucone10[Label] = new std::vector<double>;
    Muon_nucone20[Label] = new std::vector<double>;
    Muon_nucone30[Label] = new std::vector<double>;
    Muon_nucone40[Label] = new std::vector<double>;
  
    Muon_SumTrkPtInCone[Label] = new std::vector<double>;
    Muon_nTrkPtInCone[Label]   = new std::vector<int>;
    
    std::string N  = Label+"_"+"N";
    std::string NI = N+"/I";
      
    aTree->Branch(N.c_str(), &Muon_N[Label], NI.c_str());
    
    std::string pdgId  = Label+"_"+"pdgId";
    std::string m      = Label+"_"+"m";
    std::string charge = Label+"_"+"charge";
    std::string E      = Label+"_"+"E";
    std::string p_T    = Label+"_"+"p_T";
    std::string phi    = Label+"_"+"phi";
    std::string eta    = Label+"_"+"eta";
    std::string px     = Label+"_"+"px";
    std::string py     = Label+"_"+"py";
    std::string pz     = Label+"_"+"pz";
  
    aTree->Branch(pdgId.c_str(),  &Muon_pdgId[Label] );
    aTree->Branch(m.c_str(),      &Muon_m[Label]     );
    aTree->Branch(charge.c_str(), &Muon_charge[Label]);
    aTree->Branch(E.c_str(),      &Muon_E[Label]     );
    aTree->Branch(p_T.c_str(),    &Muon_p_T[Label]   );
    aTree->Branch(phi.c_str(),    &Muon_phi[Label]   );
    aTree->Branch(eta.c_str(),    &Muon_eta[Label]   );
    aTree->Branch(px.c_str(),     &Muon_px[Label]    );
    aTree->Branch(py.c_str(),     &Muon_py[Label]    );
    aTree->Branch(pz.c_str(),     &Muon_pz[Label]    );
    
    std::string author                           = Label+"_"+"author";
    std::string hasCluster                       = Label+"_"+"hasCluster";
    std::string hasCombinedMuon                  = Label+"_"+"hasCombinedMuon";
    std::string bestMatch                        = Label+"_"+"bestMatch";
    std::string isCombinedMuon                   = Label+"_"+"isCombinedMuon";
    std::string hasInDetTrackParticle            = Label+"_"+"hasInDetTrackParticle";
    std::string hasMuonExtrapolatedTrackParticle = Label+"_"+"hasMuonExtrapolatedTrackParticle";
    std::string hasCombinedMuonTrackParticle     = Label+"_"+"hasCombinedMuonTrackParticle";
  
    aTree->Branch(author.c_str(),                           &Muon_author[Label]                          );
    aTree->Branch(hasCluster.c_str(),                       &Muon_hasCluster[Label]                      );
    aTree->Branch(hasCombinedMuon.c_str(),                  &Muon_hasCombinedMuon[Label]                 );
    aTree->Branch(bestMatch.c_str(),                        &Muon_bestMatch[Label]                       );
    aTree->Branch(isCombinedMuon.c_str(),                   &Muon_isCombinedMuon[Label]                  );
    aTree->Branch(hasInDetTrackParticle.c_str(),            &Muon_hasInDetTrackParticle[Label]           );
    aTree->Branch(hasMuonExtrapolatedTrackParticle.c_str(), &Muon_hasMuonExtrapolatedTrackParticle[Label]);
    aTree->Branch(hasCombinedMuonTrackParticle.c_str(),     &Muon_hasCombinedMuonTrackParticle[Label]    );
  
    std::string matchChi2        = Label+"_"+"matchChi2";
    std::string matchChi2OverDoF = Label+"_"+"matchChi2OverDoF";
    std::string fitChi2          = Label+"_"+"fitChi2";
    std::string fitChi2OverDoF   = Label+"_"+"fitChi2OverDoF";
    
    aTree->Branch(matchChi2.c_str(),        &Muon_matchChi2[Label]       );
    aTree->Branch(matchChi2OverDoF.c_str(), &Muon_matchChi2OverDoF[Label]);
    aTree->Branch(fitChi2.c_str(),          &Muon_fitChi2[Label]         );
    aTree->Branch(fitChi2OverDoF.c_str(),   &Muon_fitChi2OverDoF[Label]  );
    
    std::string etcone10 = Label+"_"+"etcone10";
    std::string etcone20 = Label+"_"+"etcone20";
    std::string etcone30 = Label+"_"+"etcone30";
    std::string etcone40 = Label+"_"+"etcone40";
    std::string nucone10 = Label+"_"+"nucone10";
    std::string nucone20 = Label+"_"+"nucone20";
    std::string nucone30 = Label+"_"+"nucone30";
    std::string nucone40 = Label+"_"+"nucone40";
  
    aTree->Branch(etcone10.c_str(), &Muon_etcone10[Label]);
    aTree->Branch(etcone20.c_str(), &Muon_etcone20[Label]);
    aTree->Branch(etcone30.c_str(), &Muon_etcone30[Label]);
    aTree->Branch(etcone40.c_str(), &Muon_etcone40[Label]);
    aTree->Branch(nucone10.c_str(), &Muon_nucone10[Label]);
    aTree->Branch(nucone20.c_str(), &Muon_nucone20[Label]);
    aTree->Branch(nucone30.c_str(), &Muon_nucone30[Label]);
    aTree->Branch(nucone40.c_str(), &Muon_nucone40[Label]);
    
    std::string SumTrkPtInCone = Label+"_"+"SumTrkPtInCone";
    std::string nTrkPtInCone   = Label+"_"+"nTrkPtInCone";
  
    aTree->Branch(SumTrkPtInCone.c_str(), &Muon_SumTrkPtInCone[Label]);
    aTree->Branch(nTrkPtInCone.c_str(),   &Muon_nTrkPtInCone[Label]  );
    
  }
    
}

void TreeMaker::DeleteMuons()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=MuonContainerLabel.begin(); Itr!=MuonContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;
  
    delete Muon_pdgId[Label];
    delete Muon_m[Label];
    delete Muon_charge[Label];
    delete Muon_E[Label];
    delete Muon_p_T[Label];
    delete Muon_phi[Label];
    delete Muon_eta[Label];
    delete Muon_px[Label];
    delete Muon_py[Label];
    delete Muon_pz[Label];
  
    delete Muon_author[Label];
    delete Muon_hasCluster[Label];
    delete Muon_hasCombinedMuon[Label];
    delete Muon_bestMatch[Label];
    delete Muon_isCombinedMuon[Label];
    delete Muon_hasInDetTrackParticle[Label];
    delete Muon_hasMuonExtrapolatedTrackParticle[Label];
    delete Muon_hasCombinedMuonTrackParticle[Label];
  
    delete Muon_matchChi2[Label];
    delete Muon_matchChi2OverDoF[Label];
    delete Muon_fitChi2[Label];
    delete Muon_fitChi2OverDoF[Label];
  
    delete Muon_etcone10[Label];
    delete Muon_etcone20[Label];
    delete Muon_etcone30[Label];
    delete Muon_etcone40[Label];
    delete Muon_nucone10[Label];
    delete Muon_nucone20[Label];
    delete Muon_nucone30[Label];
    delete Muon_nucone40[Label];
  
    delete Muon_SumTrkPtInCone[Label];
    delete Muon_nTrkPtInCone[Label];
    
  }
    
}

void TreeMaker::ClearMuons()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=MuonContainerLabel.begin(); Itr!=MuonContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;

    Muon_N[Label] = 0;
  
    Muon_pdgId[Label]->clear();
    Muon_m[Label]->clear();
    Muon_charge[Label]->clear();
    Muon_E[Label]->clear();
    Muon_p_T[Label]->clear();
    Muon_phi[Label]->clear();
    Muon_eta[Label]->clear();
    Muon_px[Label]->clear();
    Muon_py[Label]->clear();
    Muon_pz[Label]->clear();
  
    Muon_author[Label]->clear();
    Muon_hasCluster[Label]->clear();
    Muon_hasCombinedMuon[Label]->clear();
    Muon_bestMatch[Label]->clear();
    Muon_isCombinedMuon[Label]->clear();
    Muon_hasInDetTrackParticle[Label]->clear();
    Muon_hasMuonExtrapolatedTrackParticle[Label]->clear();
    Muon_hasCombinedMuonTrackParticle[Label]->clear();
  
    Muon_matchChi2[Label]->clear();
    Muon_matchChi2OverDoF[Label]->clear();
    Muon_fitChi2[Label]->clear();
    Muon_fitChi2OverDoF[Label]->clear();
  
    Muon_etcone10[Label]->clear();
    Muon_etcone20[Label]->clear();
    Muon_etcone30[Label]->clear();
    Muon_etcone40[Label]->clear();
    Muon_nucone10[Label]->clear();
    Muon_nucone20[Label]->clear();
    Muon_nucone30[Label]->clear();
    Muon_nucone40[Label]->clear();
  
    Muon_SumTrkPtInCone[Label]->clear();
    Muon_nTrkPtInCone[Label]->clear();
    
  }
    
}

void TreeMaker::FillMuons()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=MuonContainerLabel.begin(); Itr!=MuonContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;
  
    Analysis::MuonContainer::const_iterator cItr;
  
    for(cItr=aMuonContainer[Label]->begin(); cItr!=aMuonContainer[Label]->end(); cItr++)
    {
    
      const Analysis::Muon * aMuon = *cItr;
      
      if(aMuon->pt() <= MuonPtCut[Label]) continue;
                   
      Muon_pdgId[Label]->push_back( aMuon->pdgId()  );
      Muon_m[Label]->push_back(     aMuon->m()      );
      Muon_charge[Label]->push_back(aMuon->charge() );
      Muon_E[Label]->push_back(     aMuon->e()/GeV  );
      Muon_p_T[Label]->push_back(   aMuon->pt()/GeV );
      Muon_phi[Label]->push_back(   aMuon->phi()    );
      Muon_eta[Label]->push_back(   aMuon->eta()    );
      Muon_px[Label]->push_back(    aMuon->px()/GeV );
      Muon_py[Label]->push_back(    aMuon->py()/GeV );
      Muon_pz[Label]->push_back(    aMuon->pz()/GeV );
    
      Muon_author[Label]->push_back(                          aMuon->author()                          );
      Muon_hasCluster[Label]->push_back(                      aMuon->hasCluster()                      );
      Muon_hasCombinedMuon[Label]->push_back(                 aMuon->hasCombinedMuon()                 );
      Muon_bestMatch[Label]->push_back(                       aMuon->bestMatch()                       );
      Muon_isCombinedMuon[Label]->push_back(                  aMuon->isCombinedMuon()                  );
      Muon_hasInDetTrackParticle[Label]->push_back(           aMuon->hasInDetTrackParticle()           );
      Muon_hasMuonExtrapolatedTrackParticle[Label]->push_back(aMuon->hasMuonExtrapolatedTrackParticle());
      Muon_hasCombinedMuonTrackParticle[Label]->push_back(    aMuon->hasCombinedMuonTrackParticle()    );
    
      Muon_matchChi2[Label]->push_back(       aMuon->matchChi2()       );
      Muon_matchChi2OverDoF[Label]->push_back(aMuon->matchChi2OverDoF());
      Muon_fitChi2[Label]->push_back(         aMuon->fitChi2()         );
      Muon_fitChi2OverDoF[Label]->push_back(  aMuon->fitChi2OverDoF()  );
    
      Muon_etcone10[Label]->push_back(aMuon->parameter(MuonParameters::etcone10)/GeV);
      Muon_etcone20[Label]->push_back(aMuon->parameter(MuonParameters::etcone20)/GeV);
      Muon_etcone30[Label]->push_back(aMuon->parameter(MuonParameters::etcone30)/GeV);
      Muon_etcone40[Label]->push_back(aMuon->parameter(MuonParameters::etcone40)/GeV);
      Muon_nucone10[Label]->push_back(aMuon->parameter(MuonParameters::nucone10)/GeV);
      Muon_nucone20[Label]->push_back(aMuon->parameter(MuonParameters::nucone20)/GeV);
      Muon_nucone30[Label]->push_back(aMuon->parameter(MuonParameters::nucone30)/GeV);
      Muon_nucone40[Label]->push_back(aMuon->parameter(MuonParameters::nucone40)/GeV);
    
      if(aTrackParticleContainer)
      {
    
        double SumPt    = 0;
        int    NbTracks = 0;
      
        HepLorentzVector hlvMuon = aMuon->hlv();
    
        Rec::TrackParticleContainer::const_iterator ItrTrack;
    
        for(ItrTrack=aTrackParticleContainer->begin(); ItrTrack!=aTrackParticleContainer->end(); ItrTrack++)
        {
          const Rec::TrackParticle * aTrack = *ItrTrack;
      
          HepLorentzVector hlvTrack = aTrack->hlv();
          double dR = hlvTrack.deltaR(hlvMuon);
      
          bool Select = (dR > TrackMuonDRCutMin) && (dR < TrackMuonDRCutMax) && (aTrack->pt() > TrackMuonPtCut);
      
          if(Select)
          {
            SumPt    += aTrack->pt();
	    NbTracks += 1;
          }
    
        }
      
        Muon_SumTrkPtInCone[Label]->push_back(SumPt/GeV);
        Muon_nTrkPtInCone[Label]->push_back  (NbTracks );
    
      }
    
      else
      {
        Muon_SumTrkPtInCone[Label]->push_back(-1);
        Muon_nTrkPtInCone[Label]->push_back  (-1);
      }
            
    }
      
    Muon_N[Label] = Muon_E[Label]->size();
    
  }
  
}
