#include "SingleTopDPDMaker/TreeMaker.h"

void TreeMaker::SetTauJets()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=TauJetContainerLabel.begin(); Itr!=TauJetContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;
  
    TauJet_pdgId[Label]  = new std::vector<double>;
    TauJet_m[Label]      = new std::vector<double>;
    TauJet_charge[Label] = new std::vector<double>;
    TauJet_E[Label]      = new std::vector<double>;
    TauJet_p_T[Label]    = new std::vector<double>;
    TauJet_phi[Label]    = new std::vector<double>;
    TauJet_eta[Label]    = new std::vector<double>;
    TauJet_px[Label]     = new std::vector<double>;
    TauJet_py[Label]     = new std::vector<double>;
    TauJet_pz[Label]     = new std::vector<double>;
  
    TauJet_hasAuthor_TauRec[Label]    = new std::vector<int>;
    TauJet_Likelihood[Label]          = new std::vector<double>;
    TauJet_TauElTauLikelihood[Label]  = new std::vector<double>;
    TauJet_TauJetLikelihoodOld[Label] = new std::vector<double>;
    TauJet_TauELikelihoodLowPt[Label] = new std::vector<double>;
    TauJet_TauJetNeuralNetwork[Label] = new std::vector<double>;
    TauJet_TauENeuralNetwork[Label]   = new std::vector<double>;
  
    TauJet_hasAuthor_Tau1P3P[Label] = new std::vector<int>;
    TauJet_ElectronFlag[Label]      = new std::vector<int>;
    TauJet_MuonFlag[Label]          = new std::vector<int>;
    TauJet_EgammaFlag[Label]        = new std::vector<int>;
    TauJet_DiscCut[Label]           = new std::vector<double>;
    TauJet_DiscNN[Label]            = new std::vector<double>;
    TauJet_EfficNN[Label]           = new std::vector<double>;
    TauJet_DiscPDERS[Label]         = new std::vector<double>;
    TauJet_DiscCutTMVA[Label]       = new std::vector<double>;
  
    TauJet_isTauLoose[Label]  = new std::vector<int>;
    TauJet_isTauMedium[Label] = new std::vector<int>;
    TauJet_isTauTight[Label]  = new std::vector<int>;
  
    TauJet_numTrack[Label]     = new std::vector<int>;
    TauJet_totTrkCharge[Label] = new std::vector<double>;
    TauJet_totTrkE[Label]      = new std::vector<double>;
  
    TauJet_track1_pT[Label]  = new std::vector<double>;
    TauJet_track2_pT[Label]  = new std::vector<double>;
    TauJet_track3_pT[Label]  = new std::vector<double>;
    TauJet_track1_phi[Label] = new std::vector<double>;
    TauJet_track2_phi[Label] = new std::vector<double>;
    TauJet_track3_phi[Label] = new std::vector<double>;
    TauJet_track1_eta[Label] = new std::vector<double>;
    TauJet_track2_eta[Label] = new std::vector<double>;
    TauJet_track3_eta[Label] = new std::vector<double>;
  
    std::string N  = Label+"_"+"N";
    std::string NI = N+"/I";
        
    aTree->Branch(N.c_str(), &TauJet_N[Label], NI.c_str());
    
    std::string pdgId  = Label+"_"+"pdgId";
    std::string m      = Label+"_"+"m";
    std::string charge = Label+"_"+"charge";
    std::string E      = Label+"_"+"E";
    std::string p_T    = Label+"_"+"p_T";
    std::string phi    = Label+"_"+"phi";
    std::string eta    = Label+"_"+"eta";
    std::string px     = Label+"_"+"px";
    std::string py     = Label+"_"+"py";
    std::string pz     = Label+"_"+"pz";
        
    aTree->Branch(pdgId.c_str(),  &TauJet_pdgId[Label] );
    aTree->Branch(m.c_str(),      &TauJet_m[Label]     );
    aTree->Branch(charge.c_str(), &TauJet_charge[Label]);
    aTree->Branch(E.c_str(),      &TauJet_E[Label]     );
    aTree->Branch(p_T.c_str(),    &TauJet_p_T[Label]   );
    aTree->Branch(phi.c_str(),    &TauJet_phi[Label]   );
    aTree->Branch(eta.c_str(),    &TauJet_eta[Label]   );
    aTree->Branch(px.c_str(),     &TauJet_px[Label]    );
    aTree->Branch(py.c_str(),     &TauJet_py[Label]    );
    aTree->Branch(pz.c_str(),     &TauJet_pz[Label]    );
    
    std::string hasAuthor_TauRec    = Label+"_"+"hasAuthor_TauRec";
    std::string Likelihood          = Label+"_"+"Likelihood";
    std::string TauElTauLikelihood  = Label+"_"+"TauElTauLikelihood";
    std::string TauJetLikelihoodOld = Label+"_"+"TauJetLikelihoodOld";
    std::string TauELikelihoodLowPt = Label+"_"+"TauELikelihoodLowPt";
    std::string TauJetNeuralNetwork = Label+"_"+"TauJetNeuralNetwork";
    std::string TauENeuralNetwork   = Label+"_"+"TauENeuralNetwork";
  
    aTree->Branch(hasAuthor_TauRec.c_str(),    &TauJet_hasAuthor_TauRec[Label]   );
    aTree->Branch(Likelihood.c_str(),          &TauJet_Likelihood[Label]         );
    aTree->Branch(TauElTauLikelihood.c_str(),  &TauJet_TauElTauLikelihood[Label] );
    aTree->Branch(TauJetLikelihoodOld.c_str(), &TauJet_TauJetLikelihoodOld[Label]);
    aTree->Branch(TauELikelihoodLowPt.c_str(), &TauJet_TauELikelihoodLowPt[Label]);
    aTree->Branch(TauJetNeuralNetwork.c_str(), &TauJet_TauJetNeuralNetwork[Label]);
    aTree->Branch(TauENeuralNetwork.c_str(),   &TauJet_TauENeuralNetwork[Label]  );
    
    std::string hasAuthor_Tau1P3P = Label+"_"+"hasAuthor_Tau1P3P";
    std::string ElectronFlag      = Label+"_"+"ElectronFlag";
    std::string MuonFlag          = Label+"_"+"MuonFlag";
    std::string EgammaFlag        = Label+"_"+"EgammaFlag";
    std::string DiscCut           = Label+"_"+"DiscCut";
    std::string DiscNN            = Label+"_"+"DiscNN";
    std::string EfficNN           = Label+"_"+"EfficNN";
    std::string DiscPDERS         = Label+"_"+"DiscPDERS";
    std::string DiscCutTMVA       = Label+"_"+"DiscCutTMVA";
  
    aTree->Branch(hasAuthor_Tau1P3P.c_str(), &TauJet_hasAuthor_Tau1P3P[Label]);
    aTree->Branch(ElectronFlag.c_str(),      &TauJet_ElectronFlag[Label]     );
    aTree->Branch(MuonFlag.c_str(),          &TauJet_MuonFlag[Label]         );
    aTree->Branch(EgammaFlag.c_str(),        &TauJet_EgammaFlag[Label]       );
    aTree->Branch(DiscCut.c_str(),           &TauJet_DiscCut[Label]          );
    aTree->Branch(DiscNN.c_str(),            &TauJet_DiscNN[Label]           );
    aTree->Branch(EfficNN.c_str(),           &TauJet_EfficNN[Label]          );
    aTree->Branch(DiscPDERS.c_str(),         &TauJet_DiscPDERS[Label]        );
    aTree->Branch(DiscCutTMVA.c_str(),       &TauJet_DiscCutTMVA[Label]      );
    
    std::string isTauLoose  = Label+"_"+"isTauLoose";
    std::string isTauMedium = Label+"_"+"isTauMedium";
    std::string isTauTight  = Label+"_"+"isTauTight";
  
    aTree->Branch(isTauLoose.c_str(),  &TauJet_isTauLoose[Label] );
    aTree->Branch(isTauMedium.c_str(), &TauJet_isTauMedium[Label]);
    aTree->Branch(isTauTight.c_str(),  &TauJet_isTauTight[Label] );
    
    std::string numTrack     = Label+"_"+"numTrack";
    std::string totTrkCharge = Label+"_"+"totTrkCharge";
    std::string totTrkE      = Label+"_"+"totTrkE";
  
    aTree->Branch(numTrack.c_str(),     &TauJet_numTrack[Label]);
    aTree->Branch(totTrkCharge.c_str(), &TauJet_totTrkCharge[Label]);
    aTree->Branch(totTrkE.c_str(),      &TauJet_totTrkE[Label]);
    
    std::string track1_pT  = Label+"_"+"track1_pT";
    std::string track2_pT  = Label+"_"+"track2_pT";
    std::string track3_pT  = Label+"_"+"track3_pT ";
    std::string track1_phi = Label+"_"+"track1_phi";
    std::string track2_phi = Label+"_"+"track2_phi";
    std::string track3_phi = Label+"_"+"track3_phi";
    std::string track1_eta = Label+"_"+"track1_eta";
    std::string track2_eta = Label+"_"+"track2_eta";
    std::string track3_eta = Label+"_"+"track3_eta";
  
    aTree->Branch(track1_pT.c_str(),  &TauJet_track1_pT[Label] );
    aTree->Branch(track2_pT.c_str(),  &TauJet_track2_pT[Label] );
    aTree->Branch(track3_pT.c_str(),  &TauJet_track3_pT[Label] );
    aTree->Branch(track1_phi.c_str(), &TauJet_track1_phi[Label]);
    aTree->Branch(track2_phi.c_str(), &TauJet_track2_phi[Label]);
    aTree->Branch(track3_phi.c_str(), &TauJet_track3_phi[Label]);
    aTree->Branch(track1_eta.c_str(), &TauJet_track1_eta[Label]);
    aTree->Branch(track2_eta.c_str(), &TauJet_track2_eta[Label]);
    aTree->Branch(track3_eta.c_str(), &TauJet_track3_eta[Label]);
    
  }
      
}

void TreeMaker::DeleteTauJets()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=TauJetContainerLabel.begin(); Itr!=TauJetContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;

    delete TauJet_pdgId[Label];
    delete TauJet_m[Label];
    delete TauJet_charge[Label];
    delete TauJet_E[Label];
    delete TauJet_p_T[Label];
    delete TauJet_phi[Label];
    delete TauJet_eta[Label];
    delete TauJet_px[Label];
    delete TauJet_py[Label];
    delete TauJet_pz[Label];
  
    delete TauJet_hasAuthor_TauRec[Label];
    delete TauJet_Likelihood[Label];
    delete TauJet_TauElTauLikelihood[Label];
    delete TauJet_TauJetLikelihoodOld[Label];
    delete TauJet_TauELikelihoodLowPt[Label];
    delete TauJet_TauJetNeuralNetwork[Label];
    delete TauJet_TauENeuralNetwork[Label];
  
    delete TauJet_hasAuthor_Tau1P3P[Label];
    delete TauJet_ElectronFlag[Label];
    delete TauJet_MuonFlag[Label];
    delete TauJet_EgammaFlag[Label];
    delete TauJet_DiscCut[Label];
    delete TauJet_DiscNN[Label];
    delete TauJet_EfficNN[Label];
    delete TauJet_DiscPDERS[Label];
    delete TauJet_DiscCutTMVA[Label];
  
    delete TauJet_isTauLoose[Label];
    delete TauJet_isTauMedium[Label];
    delete TauJet_isTauTight[Label];
  
    delete TauJet_numTrack[Label];
    delete TauJet_totTrkCharge[Label];
    delete TauJet_totTrkE[Label];
  
    delete TauJet_track1_pT[Label];
    delete TauJet_track2_pT[Label];
    delete TauJet_track3_pT[Label];
    delete TauJet_track1_phi[Label];
    delete TauJet_track2_phi[Label];
    delete TauJet_track3_phi[Label];
    delete TauJet_track1_eta[Label];
    delete TauJet_track2_eta[Label];
    delete TauJet_track3_eta[Label];
  
  }
    
}

void TreeMaker::ClearTauJets()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=TauJetContainerLabel.begin(); Itr!=TauJetContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;
  
    TauJet_N[Label] = 0;
  
    TauJet_pdgId[Label]->clear();
    TauJet_m[Label]->clear();
    TauJet_charge[Label]->clear();
    TauJet_E[Label]->clear();
    TauJet_p_T[Label]->clear();
    TauJet_phi[Label]->clear();
    TauJet_eta[Label]->clear();
    TauJet_px[Label]->clear();
    TauJet_py[Label]->clear();
    TauJet_pz[Label]->clear();
  
    TauJet_hasAuthor_TauRec[Label]->clear();
    TauJet_Likelihood[Label]->clear();
    TauJet_TauElTauLikelihood[Label]->clear();
    TauJet_TauJetLikelihoodOld[Label]->clear();
    TauJet_TauELikelihoodLowPt[Label]->clear();
    TauJet_TauJetNeuralNetwork[Label]->clear();
    TauJet_TauENeuralNetwork[Label]->clear();
  
    TauJet_hasAuthor_Tau1P3P[Label]->clear();
    TauJet_ElectronFlag[Label]->clear();
    TauJet_MuonFlag[Label]->clear();
    TauJet_EgammaFlag[Label]->clear();
    TauJet_DiscCut[Label]->clear();
    TauJet_DiscNN[Label]->clear();
    TauJet_EfficNN[Label]->clear();
    TauJet_DiscPDERS[Label]->clear();
    TauJet_DiscCutTMVA[Label]->clear();
  
    TauJet_isTauLoose[Label]->clear();
    TauJet_isTauMedium[Label]->clear();
    TauJet_isTauTight[Label]->clear();
  
    TauJet_numTrack[Label]->clear();
    TauJet_totTrkCharge[Label]->clear();
    TauJet_totTrkE[Label]->clear();
  
    TauJet_track1_pT[Label]->clear();
    TauJet_track2_pT[Label]->clear();
    TauJet_track3_pT[Label]->clear();
    TauJet_track1_phi[Label]->clear();
    TauJet_track2_phi[Label]->clear();
    TauJet_track3_phi[Label]->clear();
    TauJet_track1_eta[Label]->clear();
    TauJet_track2_eta[Label]->clear();
    TauJet_track3_eta[Label]->clear();
  
  }
  
}

void TreeMaker::FillTauJets()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=TauJetContainerLabel.begin(); Itr!=TauJetContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;

    Analysis::TauJetContainer::const_iterator cItr;
  
    for(cItr=aTauJetContainer[Label]->begin(); cItr!=aTauJetContainer[Label]->end(); cItr++)
    {
    
      const Analysis::TauJet * aTauJet = *cItr;
      
      if(aTauJet->pt() <= TauJetPtCut[Label]) continue;
    
      TauJet_pdgId[Label]->push_back( aTauJet->pdgId()  );
      TauJet_m[Label]->push_back(     aTauJet->m()      );
      TauJet_charge[Label]->push_back(aTauJet->charge() );
      TauJet_E[Label]->push_back(     aTauJet->e()/GeV  );
      TauJet_p_T[Label]->push_back(   aTauJet->pt()/GeV );
      TauJet_phi[Label]->push_back(   aTauJet->phi()    );
      TauJet_eta[Label]->push_back(   aTauJet->eta()    );
      TauJet_px[Label]->push_back(    aTauJet->px()/GeV );
      TauJet_py[Label]->push_back(    aTauJet->py()/GeV );
      TauJet_pz[Label]->push_back(    aTauJet->pz()/GeV );
    
      bool tauRec  = aTauJet->hasAuthor(TauJetParameters::tauRec);
      bool tau1P3P = aTauJet->hasAuthor(TauJetParameters::tau1P3P);
    
      if(tauRec)
      {
        TauJet_hasAuthor_TauRec[Label]->push_back(1);
      
        TauJet_Likelihood[Label]->push_back(         aTauJet->tauID()->discriminant(TauJetParameters::Likelihood)         );
        TauJet_TauElTauLikelihood[Label]->push_back( aTauJet->tauID()->discriminant(TauJetParameters::TauElTauLikelihood) );
        TauJet_TauJetLikelihoodOld[Label]->push_back(aTauJet->tauID()->discriminant(TauJetParameters::TauJetLikelihoodOld));
        TauJet_TauELikelihoodLowPt[Label]->push_back(aTauJet->tauID()->discriminant(TauJetParameters::TauELikelihoodLowPt));
        TauJet_TauJetNeuralNetwork[Label]->push_back(aTauJet->tauID()->discriminant(TauJetParameters::TauJetNeuralNetwork));
        TauJet_TauENeuralNetwork[Label]->push_back(  aTauJet->tauID()->discriminant(TauJetParameters::TauENeuralNetwork) );
      }
    
      else                                              
      {
        TauJet_hasAuthor_TauRec[Label]->push_back(   -1);
      
        TauJet_Likelihood[Label]->push_back(         -1);
        TauJet_TauElTauLikelihood[Label]->push_back( -1);
        TauJet_TauJetLikelihoodOld[Label]->push_back(-1);
        TauJet_TauELikelihoodLowPt[Label]->push_back(-1);
        TauJet_TauJetNeuralNetwork[Label]->push_back(-1);
        TauJet_TauENeuralNetwork[Label]->push_back(  -1);
      }
    
      if(tau1P3P)
      {
        TauJet_hasAuthor_Tau1P3P[Label]->push_back(1);
      
        TauJet_ElectronFlag[Label]->push_back(aTauJet->tauID()->flag(TauJetParameters::ElectronFlag)       );
        TauJet_MuonFlag[Label]->push_back(    aTauJet->tauID()->flag(TauJetParameters::MuonFlag)           );
        TauJet_EgammaFlag[Label]->push_back(  aTauJet->tauID()->flag(TauJetParameters::EgammaFlag)         );
      
        TauJet_DiscCut[Label]->push_back(     aTauJet->tauID()->discriminant(TauJetParameters::DiscCut)    );
        TauJet_DiscNN[Label]->push_back(      aTauJet->tauID()->discriminant(TauJetParameters::DiscNN)     );
        TauJet_EfficNN[Label]->push_back(     aTauJet->tauID()->discriminant(TauJetParameters::EfficNN)    );
        TauJet_DiscPDERS[Label]->push_back(   aTauJet->tauID()->discriminant(TauJetParameters::DiscPDERS)  );
        TauJet_DiscCutTMVA[Label]->push_back( aTauJet->tauID()->discriminant(TauJetParameters::DiscCutTMVA));
      }
    
      else
      {
        TauJet_hasAuthor_Tau1P3P[Label]->push_back(-1);
      
        TauJet_ElectronFlag[Label]->push_back(     -1);
        TauJet_MuonFlag[Label]->push_back(         -1);
        TauJet_EgammaFlag[Label]->push_back(       -1);
      
        TauJet_DiscCut[Label]->push_back(          -1);
        TauJet_DiscNN[Label]->push_back(           -1);
        TauJet_EfficNN[Label]->push_back(          -1);
        TauJet_DiscPDERS[Label]->push_back(        -1);
        TauJet_DiscCutTMVA[Label]->push_back(      -1);
      }
        
      TauJet_isTauLoose[Label]->push_back( aTauJet->tauID()->isTau(TauJetParameters::TauCutLoose) );
      TauJet_isTauMedium[Label]->push_back(aTauJet->tauID()->isTau(TauJetParameters::TauCutMedium));
      TauJet_isTauTight[Label]->push_back( aTauJet->tauID()->isTau(TauJetParameters::TauCutTight) );
        
      double TotalTrackCharge = 0;
      double TotalTrackEnergy = 0;
    
      for(unsigned int i=0; i<aTauJet->numTrack(); i++)
      {
    
        const Rec::TrackParticle * aTrack = aTauJet->track(i);
      
        if(aTrack->charge()) 
        {
          TotalTrackCharge += aTrack->charge();
        }
        else
        {
          TotalTrackCharge = -10;
	  break;
        }
      
        TotalTrackEnergy += aTrack->e();
    
      }
    
      TauJet_numTrack[Label]->push_back(    aTauJet->numTrack());
      TauJet_totTrkCharge[Label]->push_back(TotalTrackCharge   );
      TauJet_totTrkE[Label]->push_back(     TotalTrackEnergy   );
    
      if(tauRec || tau1P3P)
      {
    
        double Pt1 = aTauJet->numTrack() >= 1 ? aTauJet->track(0)->pt() : 0 ;
        double Pt2 = aTauJet->numTrack() >= 2 ? aTauJet->track(1)->pt() : 0 ;
        double Pt3 = aTauJet->numTrack() >= 3 ? aTauJet->track(2)->pt() : 0 ;
      
        TauJet_track1_pT[Label]->push_back(Pt1);
        TauJet_track2_pT[Label]->push_back(Pt2);
        TauJet_track3_pT[Label]->push_back(Pt3);
      
        double Phi1 = aTauJet->numTrack() >= 1 ? aTauJet->track(0)->phi() : 0 ;
        double Phi2 = aTauJet->numTrack() >= 2 ? aTauJet->track(1)->phi() : 0 ;
        double Phi3 = aTauJet->numTrack() >= 3 ? aTauJet->track(2)->phi() : 0 ;
      
        TauJet_track1_phi[Label]->push_back(Phi1);
        TauJet_track2_phi[Label]->push_back(Phi2);
        TauJet_track3_phi[Label]->push_back(Phi3);
      
        double Eta1 = aTauJet->numTrack() >= 1 ? aTauJet->track(0)->eta() : 0 ;
        double Eta2 = aTauJet->numTrack() >= 2 ? aTauJet->track(1)->eta() : 0 ;
        double Eta3 = aTauJet->numTrack() >= 3 ? aTauJet->track(2)->eta() : 0 ;
      
        TauJet_track1_eta[Label]->push_back(Eta1);
        TauJet_track2_eta[Label]->push_back(Eta2);
        TauJet_track3_eta[Label]->push_back(Eta3);
      
      }
    
      else
      {
      
        TauJet_track1_pT[Label]->push_back(-1);
        TauJet_track2_pT[Label]->push_back(-1);
        TauJet_track3_pT[Label]->push_back(-1);
      
        TauJet_track1_phi[Label]->push_back(-1);
        TauJet_track2_phi[Label]->push_back(-1);
        TauJet_track3_phi[Label]->push_back(-1);
      
        TauJet_track1_eta[Label]->push_back(-1);
        TauJet_track2_eta[Label]->push_back(-1);
        TauJet_track3_eta[Label]->push_back(-1);
      
      }
                    
    }
    
    TauJet_N[Label] = TauJet_E[Label]->size();
    
  }

}
