#include "SingleTopDPDMaker/TriggerDecisionInfo.h"

TriggerDecisionInfo::TriggerDecisionInfo()
{
  
  PassedTrigger     = 0;
  PassedLevel1      = 0;
  PassedLevel2      = 0;
  PassedEventFilter = 0;
  
  PassedChain.clear();
  
}

TriggerDecisionInfo::TriggerDecisionInfo(const TriggerDecisionInfo& Info)
{
  
  PassedTrigger     = Info.PassedTrigger;
  PassedLevel1      = Info.PassedLevel1;
  PassedLevel2      = Info.PassedLevel2;
  PassedEventFilter = Info.PassedEventFilter;
  PassedChain       = Info.PassedChain;
  
}

TriggerDecisionInfo::~TriggerDecisionInfo(){}

void TriggerDecisionInfo::SetPassedTrigger(int Value)
{
  PassedTrigger = Value;
}

void TriggerDecisionInfo::SetPassedLevel1(int Value)
{
  PassedLevel1 = Value;
}

void TriggerDecisionInfo::SetPassedLevel2(int Value)
{
  PassedLevel2 = Value;
}

void TriggerDecisionInfo::SetPassedEventFilter(int Value)
{
  PassedEventFilter = Value;
}

void TriggerDecisionInfo::SetPassedChain(std::map<std::string, int>& Values)
{
  PassedChain = Values;
}
  
int TriggerDecisionInfo::GetPassedTrigger() const
{
  return PassedTrigger;
}

int TriggerDecisionInfo::GetPassedLevel1() const
{
  return PassedLevel1;
}

int TriggerDecisionInfo::GetPassedLevel2() const
{
  return PassedLevel2;
}

int TriggerDecisionInfo::GetPassedEventFilter() const
{
  return PassedEventFilter;
}

std::map<std::string, int> TriggerDecisionInfo::GetPassedChain() const
{
  return PassedChain;
}
