#include "SingleTopDPDMaker/TriggerTreeMaker.h"

void TriggerTreeMaker::SetDecisionBranches()
{

  std::string PassedTG = TriggerDecisionInfoLabel+"Trigger";
  std::string PassedL1 = TriggerDecisionInfoLabel+"L1";
  std::string PassedL2 = TriggerDecisionInfoLabel+"L2";
  std::string PassedEF = TriggerDecisionInfoLabel+"EF";
  
  std::string PassedTGi = PassedTG+"/I";
  std::string PassedL1i = PassedL1+"/I";
  std::string PassedL2i = PassedL2+"/I";
  std::string PassedEFi = PassedEF+"/I";

  aTree->Branch(PassedTG.c_str(), &PassedTrigger,     PassedTGi.c_str());
  aTree->Branch(PassedL1.c_str(), &PassedLevel1,      PassedL1i.c_str());
  aTree->Branch(PassedL2.c_str(), &PassedLevel2,      PassedL2i.c_str());
  aTree->Branch(PassedEF.c_str(), &PassedEventFilter, PassedEFi.c_str());
  
  PassedChain = aTriggerDecisionInfo->GetPassedChain();
  
  std::map<std::string, int>::const_iterator Itr;
  
  for(Itr=PassedChain.begin(); Itr!=PassedChain.end(); Itr++)
  {
    std::string Name     = Itr->first;
    std::string PassedC  = TriggerDecisionInfoLabel+Name;
    std::string PassedCi = PassedC+"/I";
    
    aTree->Branch(PassedC.c_str(), &PassedChain[Name], PassedCi.c_str());
  }
  
}

void TriggerTreeMaker::ClearDecisionBranches()
{

  if(!aTriggerDecisionInfo) return;

  PassedTrigger     = -1;
  PassedLevel1      = -1;
  PassedLevel2      = -1;
  PassedEventFilter = -1;
  
  std::map<std::string, int>::const_iterator Itr;
  
  for(Itr=PassedChain.begin(); Itr!=PassedChain.end(); Itr++)
  {
    std::string Name  = Itr->first;
    PassedChain[Name] = -1;
  }
  
}

void TriggerTreeMaker::FillDecisionBranches()
{

  if(!aTriggerDecisionInfo) return;
  
  PassedTrigger     = aTriggerDecisionInfo->GetPassedTrigger();
  PassedLevel1      = aTriggerDecisionInfo->GetPassedLevel1();
  PassedLevel2      = aTriggerDecisionInfo->GetPassedLevel2();
  PassedEventFilter = aTriggerDecisionInfo->GetPassedEventFilter();
  
  PassedChain = aTriggerDecisionInfo->GetPassedChain();
    
}
