#include "SingleTopDPDMaker/TruthTreeMaker.h"

void TruthTreeMaker::SetMissingEt()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=MissingEtLabel.begin(); Itr!=MissingEtLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;

    std::vector<std::string>::const_iterator Itr;
  
    for(Itr=MissingEtSource.begin(); Itr!=MissingEtSource.end(); Itr++)
    {
  
      std::string Source = *Itr;
      
      std::string mEtx;
      std::string mEty;
      std::string mEt;
      std::string mEtSum;
      
      if(Label == "None")
      {
        mEtx   = Source+"_"+"MissingEtx";
        mEty   = Source+"_"+"MissingEty";
        mEt    = Source+"_"+"MissingEt";
        mEtSum = Source+"_"+"MissingEtSum";
      }
      
      else
      {
        mEtx   = Label+"_"+Source+"_"+"MissingEtx";
        mEty   = Label+"_"+Source+"_"+"MissingEty";
        mEt    = Label+"_"+Source+"_"+"MissingEt";
        mEtSum = Label+"_"+Source+"_"+"MissingEtSum";
      }
    
      std::string mEtxD   = mEtx+"/D";
      std::string mEtyD   = mEty+"/D";
      std::string mEtD    = mEt+"/D";
      std::string mEtSumD = mEtSum+"/D";

      aTree->Branch(mEtx.c_str(),   &MissingEtx[Label][Source],   mEtxD.c_str()  );
      aTree->Branch(mEty.c_str(),   &MissingEty[Label][Source],   mEtyD.c_str()  ); 
      aTree->Branch(mEt.c_str(),    &MissingEt[Label][Source],    mEtD.c_str()   );
      aTree->Branch(mEtSum.c_str(), &MissingEtSum[Label][Source], mEtSumD.c_str());
    
    }
  
  }
    
}

void TruthTreeMaker::ClearMissingEt()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=MissingEtLabel.begin(); Itr!=MissingEtLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;
  
    std::vector<std::string>::const_iterator Itr;
  
    for(Itr=MissingEtSource.begin(); Itr!=MissingEtSource.end(); Itr++)
    {
  
      std::string Source = *Itr;

      MissingEtx[Label][Source]   = -1;
      MissingEty[Label][Source]   = -1;
      MissingEt[Label][Source]    = -1;
      MissingEtSum[Label][Source] = -1;
      
    }
    
  }
    
}

void TruthTreeMaker::FillMissingEt()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=MissingEtLabel.begin(); Itr!=MissingEtLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;
      
    for(unsigned int i=0; i<MissingEtSource.size(); i++)
    {
  
      std::string Source = MissingEtSource[i];
    
      MissingEtTruth::TruthIndex Index = MissingEtIndex[i];
    
      double mEtx   = aMissingEt[Label]->exTruth(Index);
      double mEty   = aMissingEt[Label]->eyTruth(Index);
      double mEtSum = aMissingEt[Label]->etSumTruth(Index);

      MissingEtx[Label][Source]   = mEtx/GeV;
      MissingEty[Label][Source]   = mEty/GeV;
      MissingEt[Label][Source]    = sqrt(mEtx*mEtx+mEty*mEty)/GeV;
      MissingEtSum[Label][Source] = mEtSum/GeV;
      
    }
    
  }
  
}
