#include "SingleTopDPDMaker/TruthTreeMaker.h"

void TruthTreeMaker::SetParticles()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=ParticleContainerLabel.begin(); Itr!=ParticleContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;

    Particle_pdgId[Label]  = new std::vector<double>;
    Particle_m[Label]      = new std::vector<double>;
    Particle_charge[Label] = new std::vector<double>;
    Particle_E[Label]      = new std::vector<double>;
    Particle_p_T[Label]    = new std::vector<double>;
    Particle_phi[Label]    = new std::vector<double>;
    Particle_eta[Label]    = new std::vector<double>;
    Particle_px[Label]     = new std::vector<double>;
    Particle_py[Label]     = new std::vector<double>;
    Particle_pz[Label]     = new std::vector<double>;
    
    Particle_status[Label]  = new std::vector<int>;
    Particle_barcode[Label] = new std::vector<int>;
    
    Particle_etcone[Label]   = new std::vector<double>;
    Particle_etcone10[Label] = new std::vector<double>;
    Particle_etcone20[Label] = new std::vector<double>;
    Particle_etcone30[Label] = new std::vector<double>;
    Particle_etcone40[Label] = new std::vector<double>;
    Particle_etcone50[Label] = new std::vector<double>;
    Particle_etcone60[Label] = new std::vector<double>;
    Particle_etcone70[Label] = new std::vector<double>;
    
    Particle_nParents[Label] = new std::vector<int>;
    Particle_nDecay[Label]   = new std::vector<int>;
    
    Particle_ParentIDs[Label]      = new std::vector<std::vector<double> >;
    Particle_ParentBarcodes[Label] = new std::vector<std::vector<double> >;
    Particle_ParentStatus[Label]   = new std::vector<std::vector<double> >;
    Particle_ParentPt[Label]       = new std::vector<std::vector<double> >;
    Particle_ParentEta[Label]      = new std::vector<std::vector<double> >;
    
    Particle_DecayIDs[Label]      = new std::vector<std::vector<double> >;
    Particle_DecayBarcodes[Label] = new std::vector<std::vector<double> >;
    Particle_DecayStatus[Label]   = new std::vector<std::vector<double> >;
    Particle_DecayPt[Label]       = new std::vector<std::vector<double> >;
    Particle_DecayEta[Label]      = new std::vector<std::vector<double> >;
      
    std::string N  = Label+"_"+"N";
    std::string NI = N+"/I";
        
    aTree->Branch(N.c_str(), &Particle_N[Label], NI.c_str());
    
    std::string pdgId  = Label+"_"+"pdgId";
    std::string m      = Label+"_"+"m";
    std::string charge = Label+"_"+"charge";
    std::string E      = Label+"_"+"E";
    std::string p_T    = Label+"_"+"p_T";
    std::string phi    = Label+"_"+"phi";
    std::string eta    = Label+"_"+"eta";
    std::string px     = Label+"_"+"px";
    std::string py     = Label+"_"+"py";
    std::string pz     = Label+"_"+"pz";
        
    aTree->Branch(pdgId.c_str(),  &Particle_pdgId[Label] );
    aTree->Branch(m.c_str(),      &Particle_m[Label]     );
    aTree->Branch(charge.c_str(), &Particle_charge[Label]);
    aTree->Branch(E.c_str(),      &Particle_E[Label]     );
    aTree->Branch(p_T.c_str(),    &Particle_p_T[Label]   );
    aTree->Branch(phi.c_str(),    &Particle_phi[Label]   );
    aTree->Branch(eta.c_str(),    &Particle_eta[Label]   );
    aTree->Branch(px.c_str(),     &Particle_px[Label]    );
    aTree->Branch(py.c_str(),     &Particle_py[Label]    );
    aTree->Branch(pz.c_str(),     &Particle_pz[Label]    );
    
    std::string status  = Label+"_"+"status";
    std::string barcode = Label+"_"+"barcode";
    
    aTree->Branch(status.c_str(),  &Particle_status[Label] );
    aTree->Branch(barcode.c_str(), &Particle_barcode[Label]);
    
    std::string etcone   = Label+"_"+"etcone";
    std::string etcone10 = Label+"_"+"etcone10";
    std::string etcone20 = Label+"_"+"etcone20";
    std::string etcone30 = Label+"_"+"etcone30";
    std::string etcone40 = Label+"_"+"etcone40";
    std::string etcone50 = Label+"_"+"etcone50";
    std::string etcone60 = Label+"_"+"etcone60";
    std::string etcone70 = Label+"_"+"etcone70";
    
    aTree->Branch(etcone.c_str(),   &Particle_etcone[Label]  );
    aTree->Branch(etcone10.c_str(), &Particle_etcone10[Label]);
    aTree->Branch(etcone20.c_str(), &Particle_etcone20[Label]);
    aTree->Branch(etcone30.c_str(), &Particle_etcone30[Label]);
    aTree->Branch(etcone40.c_str(), &Particle_etcone40[Label]);
    aTree->Branch(etcone50.c_str(), &Particle_etcone50[Label]);
    aTree->Branch(etcone60.c_str(), &Particle_etcone60[Label]);
    aTree->Branch(etcone70.c_str(), &Particle_etcone70[Label]);
    
    std::string nParents = Label+"_"+"nParents";
    std::string nDecay   = Label+"_"+"nDecay";
    
    aTree->Branch(nParents.c_str(), &Particle_nParents[Label]);
    aTree->Branch(nDecay.c_str(),   &Particle_nDecay[Label]  );
    
    std::string ParentIDs      = Label+"_"+"ParentIDs";
    std::string ParentBarcodes = Label+"_"+"ParentBarcodes";
    std::string ParentStatus   = Label+"_"+"ParentStatus";
    std::string ParentPt       = Label+"_"+"ParentPt";
    std::string ParentEta      = Label+"_"+"ParentEta";
    
    aTree->Branch(ParentIDs.c_str(),      &Particle_ParentIDs[Label]     );
    aTree->Branch(ParentBarcodes.c_str(), &Particle_ParentBarcodes[Label]);
    aTree->Branch(ParentStatus.c_str(),   &Particle_ParentStatus[Label]  );
    aTree->Branch(ParentPt.c_str(),       &Particle_ParentPt[Label]      );
    aTree->Branch(ParentEta.c_str(),      &Particle_ParentEta[Label]     );
    
    std::string DecayIDs      = Label+"_"+"DecayIDs";
    std::string DecayBarcodes = Label+"_"+"DecayBarcodes";
    std::string DecayStatus   = Label+"_"+"DecayStatus";
    std::string DecayPt       = Label+"_"+"DecayPt";
    std::string DecayEta      = Label+"_"+"DecayEta";
    
    aTree->Branch(DecayIDs.c_str(),      &Particle_DecayIDs[Label]     );
    aTree->Branch(DecayBarcodes.c_str(), &Particle_DecayBarcodes[Label]);
    aTree->Branch(DecayStatus.c_str(),   &Particle_DecayStatus[Label]  );
    aTree->Branch(DecayPt.c_str(),       &Particle_DecayPt[Label]      );
    aTree->Branch(DecayEta.c_str(),      &Particle_DecayEta[Label]     ); 
          
  }
    
}

void TruthTreeMaker::DeleteParticles()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=ParticleContainerLabel.begin(); Itr!=ParticleContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;

    delete Particle_pdgId[Label];
    delete Particle_m[Label];
    delete Particle_charge[Label];
    delete Particle_E[Label];
    delete Particle_p_T[Label];
    delete Particle_phi[Label];
    delete Particle_eta[Label];
    delete Particle_px[Label];
    delete Particle_py[Label];
    delete Particle_pz[Label];
    
    delete Particle_status[Label];
    delete Particle_barcode[Label];
    
    delete Particle_etcone[Label];
    delete Particle_etcone10[Label];
    delete Particle_etcone20[Label];
    delete Particle_etcone30[Label];
    delete Particle_etcone40[Label];
    delete Particle_etcone50[Label];
    delete Particle_etcone60[Label];
    delete Particle_etcone70[Label];
    
    delete Particle_nParents[Label];
    delete Particle_nDecay[Label];
    
    delete Particle_ParentIDs[Label];
    delete Particle_ParentBarcodes[Label];
    delete Particle_ParentStatus[Label];
    delete Particle_ParentPt[Label];
    delete Particle_ParentEta[Label];
    
    delete Particle_DecayIDs[Label];
    delete Particle_DecayBarcodes[Label];
    delete Particle_DecayStatus[Label];
    delete Particle_DecayPt[Label];
    delete Particle_DecayEta[Label];
      
  }
      
}

void TruthTreeMaker::ClearParticles()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=ParticleContainerLabel.begin(); Itr!=ParticleContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;

    Particle_N[Label] = 0;

    Particle_pdgId[Label]->clear();
    Particle_m[Label]->clear();
    Particle_charge[Label]->clear();
    Particle_E[Label]->clear();
    Particle_p_T[Label]->clear();
    Particle_phi[Label]->clear();
    Particle_eta[Label]->clear();
    Particle_px[Label]->clear();
    Particle_py[Label]->clear();
    Particle_pz[Label]->clear();
    
    Particle_status[Label]->clear();
    Particle_barcode[Label]->clear();
    
    Particle_etcone[Label]->clear();
    Particle_etcone10[Label]->clear();
    Particle_etcone20[Label]->clear();
    Particle_etcone30[Label]->clear();
    Particle_etcone40[Label]->clear();
    Particle_etcone50[Label]->clear();
    Particle_etcone60[Label]->clear();
    Particle_etcone70[Label]->clear();
    
    Particle_nParents[Label]->clear();
    Particle_nDecay[Label]->clear();
    
    Particle_ParentIDs[Label]->clear();
    Particle_ParentBarcodes[Label]->clear();
    Particle_ParentStatus[Label]->clear();
    Particle_ParentPt[Label]->clear();
    Particle_ParentEta[Label]->clear();
    
    Particle_DecayIDs[Label]->clear();
    Particle_DecayBarcodes[Label]->clear();
    Particle_DecayStatus[Label]->clear();
    Particle_DecayPt[Label]->clear();
    Particle_DecayEta[Label]->clear();
  
  }
  
}

void TruthTreeMaker::FillParticles()
{

  std::vector<std::string>::const_iterator Itr;
  
  for(Itr=ParticleContainerLabel.begin(); Itr!=ParticleContainerLabel.end(); Itr++)
  {
  
    std::string Label = *Itr;

    TruthParticleContainer::const_iterator cItr;
  
    for(cItr=aParticleContainer[Label]->begin(); cItr!=aParticleContainer[Label]->end(); cItr++)
    {
    
      const TruthParticle * aParticle = *cItr;
                       
      Particle_pdgId[Label]->push_back( aParticle->pdgId()  );
      Particle_m[Label]->push_back(     aParticle->m()      );
      Particle_charge[Label]->push_back(aParticle->charge() );
      Particle_E[Label]->push_back(     aParticle->e()/GeV  );
      Particle_p_T[Label]->push_back(   aParticle->pt()/GeV );
      Particle_phi[Label]->push_back(   aParticle->phi()    );
      Particle_eta[Label]->push_back(   aParticle->eta()    );
      Particle_px[Label]->push_back(    aParticle->px()/GeV );
      Particle_py[Label]->push_back(    aParticle->py()/GeV );
      Particle_pz[Label]->push_back(    aParticle->pz()/GeV );
      
      Particle_status[Label]->push_back( aParticle->status() );
      Particle_barcode[Label]->push_back(aParticle->barcode());
      
      Particle_etcone[Label]->push_back(  aParticle->etIsol(TruthParticleParameters::etcone)  );
      Particle_etcone10[Label]->push_back(aParticle->etIsol(TruthParticleParameters::etcone10));
      Particle_etcone20[Label]->push_back(aParticle->etIsol(TruthParticleParameters::etcone20));
      Particle_etcone30[Label]->push_back(aParticle->etIsol(TruthParticleParameters::etcone30));
      Particle_etcone40[Label]->push_back(aParticle->etIsol(TruthParticleParameters::etcone40));
      Particle_etcone50[Label]->push_back(aParticle->etIsol(TruthParticleParameters::etcone50));
      Particle_etcone60[Label]->push_back(aParticle->etIsol(TruthParticleParameters::etcone60));
      Particle_etcone70[Label]->push_back(aParticle->etIsol(TruthParticleParameters::etcone70));
      
      std::vector<const TruthParticle*> ParentParticles;
      std::vector<const TruthParticle*> DecayParticles;
      
      this->GetParentParticles(aParticle, ParentParticles);
      this->GetDecayParticles (aParticle, DecayParticles );
      
      std::vector<double> ParentIDs;
      std::vector<double> ParentBarcodes;
      std::vector<double> ParentStatus;
      std::vector<double> ParentPt;
      std::vector<double> ParentEta;
    
      std::vector<double> DecayIDs;
      std::vector<double> DecayBarcodes;
      std::vector<double> DecayStatus;
      std::vector<double> DecayPt;
      std::vector<double> DecayEta;
      
      std::vector<const TruthParticle*>::const_iterator Itr;
      
      for(Itr=ParentParticles.begin(); Itr!=ParentParticles.end(); Itr++)
      {
        const TruthParticle * aParent = *Itr;
	
        ParentIDs.push_back(     aParent->pdgId()  );
	ParentBarcodes.push_back(aParent->barcode());
	ParentStatus.push_back(  aParent->status() );
	ParentPt.push_back(      aParent->pt()     );
	ParentEta.push_back(     aParent->eta()    );
      }
      
      for(Itr=DecayParticles.begin(); Itr!=DecayParticles.end(); Itr++)
      {
        const TruthParticle * aDecay = *Itr;
	
        DecayIDs.push_back(     aDecay->pdgId()  );
	DecayBarcodes.push_back(aDecay->barcode());
	DecayStatus.push_back(  aDecay->status() );
	DecayPt.push_back(      aDecay->pt()     );
	DecayEta.push_back(     aDecay->eta()    );
      }
      
      Particle_nParents[Label]->push_back(ParentParticles.size());
      Particle_nDecay[Label]->push_back(  DecayParticles.size() );
      
      Particle_ParentIDs[Label]->push_back(     ParentIDs     );
      Particle_ParentBarcodes[Label]->push_back(ParentBarcodes);
      Particle_ParentStatus[Label]->push_back(  ParentStatus  );
      Particle_ParentPt[Label]->push_back(      ParentPt      );
      Particle_ParentEta[Label]->push_back(     ParentEta     );
    
      Particle_DecayIDs[Label]->push_back(     DecayIDs     );
      Particle_DecayBarcodes[Label]->push_back(DecayBarcodes);
      Particle_DecayStatus[Label]->push_back(  DecayStatus  );
      Particle_DecayPt[Label]->push_back(      DecayPt      );
      Particle_DecayEta[Label]->push_back(     DecayEta     );
    
    }
    
    Particle_N[Label] = Particle_E[Label]->size();
    
  }
  
}

void TruthTreeMaker::GetParentParticles(const TruthParticle * aParticle, std::vector<const TruthParticle*>& ParentParticles)
{

  int ParentNumber  = aParticle->nParents();
  int ParticleIdent = aParticle->pdgId();

  for(int i=0; i<ParentNumber; i++)
  {
    
    const TruthParticle * aParent = aParticle->mother(i);
    int ParentIdent = aParent->pdgId();
    
    if(ParticleIdent != ParentIdent) ParentParticles.push_back(aParent);
    
    this->GetParentParticles(aParent, ParentParticles);
    
  }

}

void TruthTreeMaker::GetDecayParticles(const TruthParticle * aParticle, std::vector<const TruthParticle*>& DecayParticles)
{

  int DecayNumber = aParticle->nDecay();

  for(int i=0; i<DecayNumber; i++)
  {
    const TruthParticle * aDecay = aParticle->child(i);
    DecayParticles.push_back(aDecay);
  }
  
}
