#include "SingleTopDPDMaker/EventFilter.h"
#include "SingleTopDPDMaker/OverlapFilter.h"
#include "SingleTopDPDMaker/TriggerDecisionFilter.h"
#include "SingleTopDPDMaker/ElectronEtaCrackFilter.h"

#include "SingleTopDPDMaker/TreeMaker.h"
#include "SingleTopDPDMaker/TruthTreeMaker.h"
#include "SingleTopDPDMaker/TriggerTreeMaker.h"
#include "SingleTopDPDMaker/NtupleMaker.h"

#include "SingleTopDPDMaker/JetSlimming.h"
#include "SingleTopDPDMaker/TrackSlimming.h"
#include "SingleTopDPDMaker/TriggerSlimming.h"
#include "SingleTopDPDMaker/ContainerThinning.h"

#include "SingleTopDPDMaker/PhotonSelection.h"
#include "SingleTopDPDMaker/ElectronSelection.h"
#include "SingleTopDPDMaker/MuonSelection.h"
#include "SingleTopDPDMaker/TauJetSelection.h"
#include "SingleTopDPDMaker/JetSelection.h"
#include "SingleTopDPDMaker/TaggedJetSelection.h"
#include "SingleTopDPDMaker/UntaggedJetSelection.h"

#include "SingleTopDPDMaker/L1TriggerSelection.h"
#include "SingleTopDPDMaker/L2TriggerSelection.h"
#include "SingleTopDPDMaker/EFTriggerSelection.h"

#include "SingleTopDPDMaker/TruthVertexFilter.h"
#include "SingleTopDPDMaker/TruthParticleSelection.h"

#include "GaudiKernel/DeclareFactoryEntries.h"

DECLARE_ALGORITHM_FACTORY(EventFilter)
DECLARE_ALGORITHM_FACTORY(OverlapFilter)
DECLARE_ALGORITHM_FACTORY(TriggerDecisionFilter)
DECLARE_ALGORITHM_FACTORY(ElectronEtaCrackFilter)

DECLARE_ALGORITHM_FACTORY(TreeMaker)
DECLARE_ALGORITHM_FACTORY(TruthTreeMaker)
DECLARE_ALGORITHM_FACTORY(TriggerTreeMaker)
DECLARE_ALGORITHM_FACTORY(NtupleMaker)

DECLARE_ALGORITHM_FACTORY(JetSlimming)
DECLARE_ALGORITHM_FACTORY(TrackSlimming)
DECLARE_ALGORITHM_FACTORY(TriggerSlimming)
DECLARE_ALGORITHM_FACTORY(ContainerThinning)

DECLARE_ALGORITHM_FACTORY(PhotonSelection)
DECLARE_ALGORITHM_FACTORY(ElectronSelection)
DECLARE_ALGORITHM_FACTORY(MuonSelection)
DECLARE_ALGORITHM_FACTORY(TauJetSelection)
DECLARE_ALGORITHM_FACTORY(JetSelection)
DECLARE_ALGORITHM_FACTORY(TaggedJetSelection)
DECLARE_ALGORITHM_FACTORY(UntaggedJetSelection)

DECLARE_ALGORITHM_FACTORY(L1TriggerSelection)
DECLARE_ALGORITHM_FACTORY(L2TriggerSelection)
DECLARE_ALGORITHM_FACTORY(EFTriggerSelection)

DECLARE_ALGORITHM_FACTORY(TruthVertexFilter)
DECLARE_ALGORITHM_FACTORY(TruthParticleSelection)

DECLARE_FACTORY_ENTRIES(SingleTopDPDMaker)
{
  
  DECLARE_ALGORITHM(EventFilter)
  DECLARE_ALGORITHM(OverlapFilter)
  DECLARE_ALGORITHM(TriggerDecisionFilter)
  DECLARE_ALGORITHM(ElectronEtaCrackFilter)
  
  DECLARE_ALGORITHM(TreeMaker)
  DECLARE_ALGORITHM(TruthTreeMaker)
  DECLARE_ALGORITHM(TriggerTreeMaker)
  DECLARE_ALGORITHM(NtupleMaker)
  
  DECLARE_ALGORITHM(JetSlimming)
  DECLARE_ALGORITHM(TrackSlimming)
  DECLARE_ALGORITHM(TriggerSlimming)
  DECLARE_ALGORITHM(ContainerThinning)
  
  DECLARE_ALGORITHM(PhotonSelection)
  DECLARE_ALGORITHM(ElectronSelection)
  DECLARE_ALGORITHM(MuonSelection)
  DECLARE_ALGORITHM(TauJetSelection)
  DECLARE_ALGORITHM(JetSelection)
  DECLARE_ALGORITHM(TaggedJetSelection)
  DECLARE_ALGORITHM(UntaggedJetSelection)
  
  DECLARE_ALGORITHM(L1TriggerSelection)
  DECLARE_ALGORITHM(L2TriggerSelection)
  DECLARE_ALGORITHM(EFTriggerSelection)
  
  DECLARE_ALGORITHM(TruthVertexFilter)
  DECLARE_ALGORITHM(TruthParticleSelection)
      
}
