#!/bin/bash
echo "**************"
echo "* Paramtres *"
echo "**************"
echo "Analysis package archive: "${1}
echo "Job option file: "${2}
echo "Dataset: "${3}
echo "Dataset file: "${4}
echo "Output dataset: "${5}
echo "***********************************************"
echo "* Initialisation de l'environnement ATLAS     *"
echo "***********************************************"
source $VO_ATLAS_SW_DIR/software/14.2.21/setup.sh -tag=14.2.21,setup
source $SITEROOT/AtlasOffline/14.2.21/AtlasaOfflineRunTime/cmt/setup.sh
echo "*****************************************"
echo "* Initialisation de l'environnement LFC *"
echo "*****************************************"
export LFC_HOST=lfc-prod.in2p3.fr
echo "***********************************************"
echo "* Initialisation de l'environnement CMT       *"
echo "***********************************************"
export CMTPATH=`pwd`:${CMTPATH}
echo "***********************************************"
echo "* Initialisation de l'environnement DQ2       *"
echo "***********************************************"
source $VO_ATLAS_SW_DIR/ddm/latest/setup.sh
echo "****************************"
echo "* Decompression du package *"
echo "****************************"
tar -xvzf ${1}
echo "**************************"
echo "* Compilation du package *"
echo "**************************"
cd  SingleTopDPDMaker/cmt
cmt config
source setup.sh
gmake
echo "******************************************************"
echo "* Placement dans le repertoire run du package *"
echo "******************************************************"
cd ../run
echo "************************************"
echo "* Recuperation du fichier d'entree *"
echo "************************************"
echo "dq2-get -D  -L IN2P3-LPSC_LOCALGROUPDISK -f" ${4} ${3}
dq2-get -D  -L IN2P3-LPSC_LOCALGROUPDISK -f ${4} ${3}
ls -als
echo "*******************************************************"
echo "* Renommage du fichier d'entree avec un nom generique *"
echo "* utilise dans le fichier job option                  *"
echo "*******************************************************"
mv ${4} jobInput.root
ls -als
echo "********************************************************************"
echo "* Execution d'athena avec le fichier job option passe en parametre *"
echo "********************************************************************"
athena.py ${2}
ls -als
echo "*********************************************************************"
echo "* Renommage du fichier de sortie pour avec nom fonction de l'entree *"
echo "*********************************************************************"
mv jobOutput.root user.flambert.${4}
ls -als
echo "********************************************"
echo "* Ajout du fichier dans le output dataset  *"
echo "********************************************"
echo "dq2-put -a -L IN2P3-LPSC_LOCALGROUPDISK -f" user.flambert.${4} ${3}
dq2-put -a -L IN2P3-LPSC_LOCALGROUPDISK -f user.flambert.${4} ${5}